mainForm = nil;
smallForm = nil;
partyDefs = nil;
skillList = nil;
currentParty = 1;
currentLevel = 1;

function init()

	partyDefs = {
		{
			{
				class = "fighter",
				skills = {"light_weapons", "armors", "light_weapons", "armors", "light_weapons", "armors", "accuracy", "critical", "light_weapons", "armors", "light_weapons", "armors"}
			},
			{
				class = "barbarian",
				skills = {"heavy_weapons", "armors", "heavy_weapons", "armors", "heavy_weapons", "armors", "accuracy", "critical", "heavy_weapons", "armors", "heavy_weapons", "armors"}
			},	
			{
				class = "alchemist",
				skills = {"alchemy", "firearms", "alchemy", "firearms", "missile_weapons", "alchemy", "firearms", "missile_weapons", "dodge", "alchemy", "firearms", "missile_weapons"}
			},				
			{
				class = "wizard",
				skills = {"fire_magic", "water_magic", "fire_magic", "concentration", "fire_magic", "concentration", "water_magic", "fire_magic", "concentration", "water_magic", "fire_magic", "water_magic"}
			},	
		},
		{
			{
				class = "battle_mage",
				skills = {"light_weapons", "fire_magic", "light_weapons", "armors", "fire_magic", "light_weapons", "earth_magic", "fire_magic", "light_weapons", "earth_magic", "concentration", "armors"}
			},			
			{
				class = "knight",
				skills = {"heavy_weapons", "armors", "heavy_weapons", "armors", "heavy_weapons", "armors", "accuracy", "critical", "heavy_weapons", "armors", "heavy_weapons", "armors"}
			},
			{
				class = "rogue",
				skills = {"throwing", "missile_weapons", "alchemy", "throwing", "missile_weapons", "alchemy", "throwing", "missile_weapons", "alchemy", "missile_weapons", "missile_weapons", "dodge"}
			},				
			{
				class = "wizard",
				skills = {"fire_magic", "water_magic", "fire_magic", "concentration", "fire_magic", "concentration", "water_magic", "fire_magic", "concentration", "water_magic", "fire_magic", "water_magic"}
			},	
		}		
	}

	skillList = {"alchemy", "athletics", "concentration", "light_weapons", "heavy_weapons", "missile_weapons", "throwing", "firearms", "accuracy", "critical", "armors", "dodge", "fire_magic", "air_magic", "earth_magic", "water_magic"}

	smallForm = {
		name = "editorHelperSmall",
		type = "GWindow",
		gravity = GTK.Constants.Gravity.NorthEast,
		offset = {-6, 6},
		size = {32, 24},
		bgColor = {0, 0, 0, 0},
		children = {
			{
				type = "GPushButton",
				position = {0, 0},
				size = {32, 24},
				bgColor = {0, 0, 0, 200},
				label = {
					padding = {4, 4, 4, 4},
					text = "...",
				},			
				bgDrawMode = GTK.Constants.ImageDrawMode.Stretched,
				onPressed = self.go.id .. ".script.toggleMainForm"				
			},	
		}
	}

	mainForm = {
		name = "editorHelperMain",
		type = "GWindow",
		gravity = GTK.Constants.Gravity.NorthEast,
		offset = {-2, 30},
		size = {230, 140},
		bgColor = {0, 0, 0, 200},
		bgDrawMode = GTK.Constants.ImageDrawMode.Stretched,
		draggable = true,
		children = {
			{
				type = "GWidget",
				position = {10, 10},
				size = {100, 120},
				bgColor = {255, 255, 255, 50},
				children = {
					{
						type = "GLabel",
						position = {10, 4},
						size = {78, 18},
						text = "Set Time",
						textAlign = GTK.Constants.TextAlign.Center,
					},
					{
						type = "GPushButton",
						position = {4, 24},
						size = {44, 20},
						bgColor = {0, 0, 0, 200},
						label = {
							padding = {4, 4, 4, 4},
							text = "6:00",
						},			
						bgDrawMode = GTK.Constants.ImageDrawMode.Stretched,
						onPressed = self.go.id .. ".script.setTime0600"
					},	
					{
						type = "GPushButton",
						position = {52, 24},
						size = {44, 20},
						bgColor = {0, 0, 0, 200},
						label = {
							padding = {4, 4, 4, 4},
							text = "9:00",
						},			
						bgDrawMode = GTK.Constants.ImageDrawMode.Stretched,
						onPressed = self.go.id .. ".script.setTime0900"
					},	
					{
						type = "GPushButton",
						position = {4, 48},
						size = {44, 20},
						bgColor = {0, 0, 0, 200},
						label = {
							padding = {4, 4, 4, 4},
							text = "12:00",
						},			
						bgDrawMode = GTK.Constants.ImageDrawMode.Stretched,
						onPressed = self.go.id .. ".script.setTime1200"
					},		
					{
						type = "GPushButton",
						position = {52, 48},
						size = {44, 20},
						bgColor = {0, 0, 0, 200},
						label = {
							padding = {4, 4, 4, 4},
							text = "15:00",
						},			
						bgDrawMode = GTK.Constants.ImageDrawMode.Stretched,
						onPressed = self.go.id .. ".script.setTime1500"
					},	
					{
						type = "GPushButton",
						position = {4, 72},
						size = {44, 20},
						bgColor = {0, 0, 0, 200},
						label = {
							padding = {4, 4, 4, 4},
							text = "18:00",
						},			
						bgDrawMode = GTK.Constants.ImageDrawMode.Stretched,
						onPressed = self.go.id .. ".script.setTime1800"
					},		
					{
						type = "GPushButton",
						position = {52, 72},
						size = {44, 20},
						bgColor = {0, 0, 0, 200},
						label = {
							padding = {4, 4, 4, 4},
							text = "21:00",
						},			
						bgDrawMode = GTK.Constants.ImageDrawMode.Stretched,
						onPressed = self.go.id .. ".script.setTime2100"
					},	
					{
						type = "GPushButton",
						position = {4, 96},
						size = {44, 20},
						bgColor = {0, 0, 0, 200},
						label = {
							padding = {4, 4, 4, 4},
							text = "-1 H",
						},			
						bgDrawMode = GTK.Constants.ImageDrawMode.Stretched,
						onPressed = self.go.id .. ".script.backOneHour"
					},		
					{
						type = "GPushButton",
						position = {52, 96},
						size = {44, 20},
						bgColor = {0, 0, 0, 200},
						label = {
							padding = {4, 4, 4, 4},
							text = "+1 H",
						},			
						bgDrawMode = GTK.Constants.ImageDrawMode.Stretched,
						onPressed = self.go.id .. ".script.advanceOneHour"
					},	
				}
			},
			{
				type = "GWidget",
				position = {120, 10},
				size = {100, 120},
				bgColor = {255, 255, 255, 50},
				children = {
					{
						type = "GLabel",
						position = {10, 4},
						size = {78, 18},
						text = "Party",
						textAlign = GTK.Constants.TextAlign.Center,
					},
					{
						type = "GPushButton",
						position = {4, 24},
						size = {44, 20},
						bgColor = {0, 0, 0, 200},
						label = {
							padding = {4, 4, 4, 4},
							text = "Pty 1",
						},			
						bgDrawMode = GTK.Constants.ImageDrawMode.Stretched,
						onPressed = self.go.id .. ".script.setParty1"
					},	
					{
						type = "GPushButton",
						position = {52, 24},
						size = {44, 20},
						bgColor = {0, 0, 0, 200},
						label = {
							padding = {4, 4, 4, 4},
							text = "Pty 2",
						},			
						bgDrawMode = GTK.Constants.ImageDrawMode.Stretched,
						onPressed = self.go.id .. ".script.setParty2"
					},	
					{
						type = "GPushButton",
						position = {4, 48},
						size = {44, 20},
						bgColor = {0, 0, 0, 200},
						label = {
							padding = {4, 4, 4, 4},
							text = "L 1",
						},			
						bgDrawMode = GTK.Constants.ImageDrawMode.Stretched,
						onPressed = self.go.id .. ".script.setLevel1"
					},		
					{
						type = "GPushButton",
						position = {52, 48},
						size = {44, 20},
						bgColor = {0, 0, 0, 200},
						label = {
							padding = {4, 4, 4, 4},
							text = "L 4",
						},			
						bgDrawMode = GTK.Constants.ImageDrawMode.Stretched,
						onPressed = self.go.id .. ".script.setLevel4"
					},	
					{
						type = "GPushButton",
						position = {4, 72},
						size = {44, 20},
						bgColor = {0, 0, 0, 200},
						label = {
							padding = {4, 4, 4, 4},
							text = "L 7",
						},			
						bgDrawMode = GTK.Constants.ImageDrawMode.Stretched,
						onPressed = self.go.id .. ".script.setLevel7"
					},		
					{
						type = "GPushButton",
						position = {52, 72},
						size = {44, 20},
						bgColor = {0, 0, 0, 200},
						label = {
							padding = {4, 4, 4, 4},
							text = "L 10",
						},			
						bgDrawMode = GTK.Constants.ImageDrawMode.Stretched,
						onPressed = self.go.id .. ".script.setLevel10"
					},		
					{
						type = "GPushButton",
						position = {4, 96},
						size = {44, 20},
						bgColor = {0, 0, 0, 200},
						label = {
							padding = {4, 4, 4, 4},
							text = "-1",
						},			
						bgDrawMode = GTK.Constants.ImageDrawMode.Stretched,
						onPressed = self.go.id .. ".script.levelDown"
					},		
					{
						type = "GPushButton",
						position = {52, 96},
						size = {44, 20},
						bgColor = {0, 0, 0, 200},
						label = {
							padding = {4, 4, 4, 4},
							text = "+1",
						},			
						bgDrawMode = GTK.Constants.ImageDrawMode.Stretched,
						onPressed = self.go.id .. ".script.levelUp"
					},		
				}
			},
		}
	}
end

function toggleMainForm()
	if Editor.IsRunning == false then
		return
	end

	local mainWindow = GTK.Core.GUI:getWindow(mainForm.name) 

	if ( mainWindow and mainWindow.data.visible ) then
		hideMainForm()
	else
		showMainForm()
	end
end

function showMainForm()
	if Editor.IsRunning == false then
		return
	end

	if ( GTK.Core.GUI:getWindow(mainForm.name) == nil ) then 	
		GTK.Core.GUI:createWindow(mainForm);
	else 
		GTK.Core.GUI:showWindow(mainForm.name);
	end
end

function showSmallForm()
	if Editor.IsRunning == false then
		return
	end

	if ( GTK.Core.GUI:getWindow(smallForm.name) == nil ) then 	
		GTK.Core.GUI:createWindow(smallForm);
	else 
		GTK.Core.GUI:showWindow(smallForm.name);
	end
end

function hideMainForm()
	if ( GTK.Core.GUI:getWindow(mainForm.name) ) then 	
		GTK.Core.GUI:hideWindow(mainForm.name);
	end		
end

function hideSmallForm()
	if ( GTK.Core.GUI:getWindow(smallForm.name) ) then 	
		GTK.Core.GUI:hideWindow(smallForm.name);
	end	
end

function gtkDidLoad()
	if Editor.IsRunning == false then
		return
	end

	init();
	showSmallForm();
end


--
-- TIME OF DAY
--

function setTimeOfDay(hour)
	t = ((hour % 24) - 9) / 12.0
	GameMode.setTimeOfDay(t)
end

function setTime0600() 		setTimeOfDay(6)		end
function setTime0900() 		setTimeOfDay(9)		end
function setTime1200() 		setTimeOfDay(12)	end
function setTime1500() 		setTimeOfDay(15)	end
function setTime1800() 		setTimeOfDay(18)	end
function setTime2100() 		setTimeOfDay(21)	end

function backOneHour()
	local t = GameMode:getTimeOfDay()
    t = math.floor((t*12+9)%24)

    setTimeOfDay(t - 1)
end

function advanceOneHour()
	local t = GameMode:getTimeOfDay()
    t = math.floor((t*12+9)%24)

	setTimeOfDay(t + 1)
end


--
-- PARTY / SET LEVEL
--

function setPartyAndLevel(partyId, level)
	if level < 1 then level = 1 end

	currentParty = partyId;
	currentLevel = level;

	local partyDef = partyDefs[partyId];

	if partyDef == nil then
		return
	end

	for partyIndex=1,4 do
		local champion = party.party:getChampion(partyIndex)
		champion:resetExp()

		for _,skill in pairs(skillList) do
			champion:trainSkill(skill, -champion:getSkillLevel(skill))		
		end	

		champion:setClass(partyDef[partyIndex]['class'])
		champion:setSkillPoints(0)		

		for i=1,level do
			if i>1 then
				champion:levelUp()
			end

			if partyDef[partyIndex]['skills'][i] then
				champion:trainSkill(partyDef[partyIndex]['skills'][i], 1)
			end
		end

		champion:setHealth(champion:getMaxHealth())
		champion:setEnergy(champion:getMaxEnergy())
	end
end


function setParty1() 			setPartyAndLevel(1, currentLevel)		end
function setParty2() 			setPartyAndLevel(2, currentLevel)		end

function setLevel1()			setPartyAndLevel(currentParty, 1)		end
function setLevel4()			setPartyAndLevel(currentParty, 4)		end
function setLevel7()			setPartyAndLevel(currentParty, 7)		end
function setLevel10()			setPartyAndLevel(currentParty, 10)		end


function levelUp()
	setPartyAndLevel(currentParty, currentLevel + 1)
end

function levelDown()
	setPartyAndLevel(currentParty, currentLevel - 1)
end


