
--
--ItemSlot.Weapon = 1	
--ItemSlot.OffHand = 2	
--ItemSlot.Head = 3	
--ItemSlot.Chest = 4	
--ItemSlot.Legs = 5	
--ItemSlot.Feet = 6	
--ItemSlot.Cloak = 7	
--ItemSlot.Necklace = 8	
--ItemSlot.Gloves = 9	
--ItemSlot.Bracers = 10	
--ItemSlot.Weapon2 = 11	
--ItemSlot.OffHand2 = 12	
--ItemSlot.BackpackFirst = 13	
--ItemSlot.BackpackLast = 32	
--ItemSlot.MaxSlots = 32
--


function doStartingGear()
	local basicGear = {}
	basicGear[ItemSlot.Chest] = "tattered_shirt"
	basicGear[ItemSlot.Legs] = "loincloth"
	basicGear[ItemSlot.Feet] = "sandals"
	basicGear[ItemSlot.BackpackFirst] = "pitroot_bread"
	
	local classGear = {}
	classGear["barbarian"] = { }
	classGear["barbarian"][ItemSlot.Weapon] = "bone_club"
	classGear["wizard"] = { }
	classGear["wizard"][ItemSlot.OffHand] = "torch"

	for partyIndex=1,4 do
		local champion = party.party:getChampion(partyIndex)
		local class = champion:getClass()
		local gear = {}

		for slot,value in pairs(basicGear) do
			gear[slot] = value
		end

		if classGear[class] ~= nil then
			for slot,value in pairs(classGear[class]) do
				gear[slot] = value
			end
		end

		for slot,value in pairs(gear) do 
			local go = spawn(value)
			champion:removeItemFromSlot(slot)
			champion:insertItem(slot, go.item)			
		end
	end
end

function gtkDidLoad()
	doStartingGear()
end