--
-- Additional Traits for ORRR3
--


-- 
-- Racial Traits
--

defineTrait{
	name = "fey_born",
	uiName = "Fey Born",
	icon = 37,
	description = "As a Fey Born you look mostly human but carry within you the powerful blood of your Fey lineage. However, all Fey Born have traits that set them apart from humans and those who learn of your true nature tend to distrust you for being different.\n- Dexterity +2, Willpower +3, Strength -2, Vitality -2\n- Energy +10",
	onRecomputeStats = function(champion, level)
		if level > 0 then
			champion:addStatModifier("dexterity", 2)			
			champion:addStatModifier("willpower", 3)
			champion:addStatModifier("strength", -2)			
			champion:addStatModifier("vitality", -2)
			champion:addStatModifier("max_energy", 10)
		end
	end,
}


--
-- Class Traits
--

defineTrait{
	name = "skald",
	uiName = "Skald (Bard)",
	icon = 97,
	description = "As a Skald you are able to channel magical energy through performance and song, inspiring or causing fear in those around you.",
	gameEffect = [[
	- Health 40 (+4 per level), Energy 50 (+6 per level).
	- Can use more powerful effects from instruments and songs using the Perform skill.]],
	onRecomputeStats = function(champion, level)
		if level > 0 then
			level = champion:getLevel()
			champion:addStatModifier("max_health", 40 + (level-1) * 4)
			champion:addStatModifier("max_energy", 50 + (level-1) * 6)
		end
	end,
}

defineTrait{
	name = "templar",
	uiName = "Templar",
	icon = 97,
	description = "As a Holy Warrior you are guided by the mystical energies of Xafi. You are primarily a warrior but can call upon Xafi's might to protect yourself in battle.",
	gameEffect = [[
	- Health 50 (+5 per level), Energy 50 (+5 per level).
	- Protection +1 per level.
	- Light magic spells are 20% more effective.]],
	onRecomputeStats = function(champion, level)
		if level > 0 then
			level = champion:getLevel()
			champion:addStatModifier("max_health", 50 + (level-1) * 5)
			champion:addStatModifier("max_energy", 50 + (level-1) * 5)
			champion:addStatModifier("protection", level)
		end
	end,
}

defineTrait{
	name = "witch",
	uiName = "Witch",
	icon = 97,
	description = "As a Witch you practice alternative magics to normal wizards, wielding mystical secrets and calling down magical curses upon your enemies.",
	gameEffect = [[
	- Health 35 (+3 per level), Energy 50 (+7 per level)
	- Can cast spells with bare hands.
	- Can use spell components to curse enemies.
	- Can brew special potions with alchemist skill.]],
	onRecomputeStats = function(champion, level)
		if level > 0 then
			level = champion:getLevel()
			champion:addStatModifier("max_health", 35 + (level-1) * 3)
			champion:addStatModifier("max_energy", 50 + (level-1) * 7)
		end
	end,
}


--
-- Skill Traits
--

defineTrait{
	name = "life_mastery",
	uiName = "Life Mastery",
	icon = 97,
	description = "You gain +30 health",
	onRecomputeStats = function(champion, level)
		if level > 0 then
			level = champion:getLevel()
			champion:addStatModifier("max_health", 30)
		end
	end,	
}

defineTrait{
	name = "death_mastery",
	uiName = "Death Mastery",
	icon = 97,
	description = "??",
	onRecomputeStats = function(champion, level)
		if level > 0 then
			level = champion:getLevel()
		end
	end,	
}

