form = nil;
formName = "demo03";
currentIndex = 0;

function gtkDidLoad()	
	form = {
		name = formName,
		type = "GWindow",
		gravity = GTK.Constants.Gravity.North,
		offset = {0, 0},
		size = {626, 148},
		bgColor = {0, 0, 0, 0},
		bgImage = "panel-bg",
		bgDrawMode = GTK.Constants.ImageDrawMode.Stretched,
		draggable = true,
		freezeAI = true,
		children = {
			{
				type = "GLabel",
				position = {14, 14},
				size = {300, 20},
				text = "Built-in Icon Browser",
				textAlign = GTK.Constants.TextAlign.Left,
			},
			{
				type = "GIcon",
				name = "mainIcon1",
				position = {14, 36},
				size = {75, 75},
				bgColor = {0, 0, 0, 50},
				borderColor = {0, 0, 0, 255},
				borders = {1, 1, 1, 1},
				gfxIndex = 0,
			},
			{
				type = "GIcon",
				name = "mainIcon2",
				position = {96, 36},
				size = {50, 50},
				bgColor = {0, 0, 0, 50},
				borderColor = {0, 0, 0, 255},
				borders = {1, 1, 1, 1},
				gfxIndex = 0,
			},
			{
				type = "GIcon",
				name = "mainIcon3",
				position = {154, 36},
				size = {25, 25},
				bgColor = {0, 0, 0, 50},
				borderColor = {0, 0, 0, 255},
				borders = {1, 1, 1, 1},
				gfxIndex = 0,
			},
			{
				type = "GLabel",
				position = {14, 116},
				size = {75, 20},
				text = "gfxIndex: ",
				textAlign = GTK.Constants.TextAlign.Left,
			},
			{
				type = "GTextEdit",
				name = "indexTextEdit",
				position = {94, 116},
				size = {75, 20},
				text = "0",
				textAlign = GTK.Constants.TextAlign.Left,
				onLoseFocus = self.go.id .. ".script.textEditUpdated"
			},
			{
				type = "GPushButton",
				position = {400, 14},
				size = {210, 24},
				label = {
					padding = {4, 4, 4, 4},
					text = "Previous (O)",
				},
				keyboardShortcut = "O",
				onPressed = self.go.id .. ".script.previousButton"
			},
			{
				type = "GPushButton",
				position = {400, 44},
				size = {210, 24},
				label = {
					padding = {4, 4, 4, 4},
					text = "Next (P)",
				},
				keyboardShortcut = "P",
				onPressed = self.go.id .. ".script.nextButton"
			},

		}
	}

end

function setIndex(index)
	if ( index < 0 ) then index = 0 end
	currentIndex = index;

	local window = GTK.Core.GUI:getWindow(formName);

	if ( window == nil ) then
		return;
	end

	local icon1 = window:findChild("mainIcon1");
	local icon2 = window:findChild("mainIcon2");
	local icon3 = window:findChild("mainIcon3");
	local indexTextEdit = window:findChild("indexTextEdit");

	if ( icon1 and icon2 and icon3 and indexTextEdit ) then
		icon1.data.gfxIndex = index;
		icon2.data.gfxIndex = index;
		icon3.data.gfxIndex = index;

		indexTextEdit.data.text = tostring(index);
	end
end

function textEditUpdated(sender)
	setIndex(tonumber(sender.data.text));
end

function previousButton(sender, mouseState)
	local nextIndex = currentIndex - 1;

	if ( (nextIndex % 200) >= 169 ) then
		local sheet = math.floor(nextIndex / 200);
		setIndex((sheet * 200) + 168);
	else 
		setIndex(nextIndex);
	end
end

function nextButton(sender, mouseState)
	local nextIndex = currentIndex + 1;

	if ( (nextIndex % 200) >= 169 ) then
		local sheet = math.floor(nextIndex / 200) + 1;
		setIndex((sheet * 200));
	else 
		setIndex(nextIndex);
	end
end


function showGui()
	if ( GTK.Core.GUI:getWindow(formName) == nil ) then 	
		GTK.Core.GUI:createWindow(form);
	else 
		GTK.Core.GUI:showWindow(formName);
	end
end

function hideGui()
	GTK.Core.GUI:hideWindow(formName);
end
