
------------------------------------------------------------------------
-- Dialogue Example 1
--
-- An example of using the dialogue system manually to make more custom
-- conversations.
------------------------------------------------------------------------

isDone = false;

-- Public Functions (pressure plate methods)

function showDemoDialogue(sender)
	if ( isDone ) then
		return;
	end

	_showIntroPage();
end


function hideDemoDialogue()
	GTKGui.Dialogue.hideDialogue();
end

-- Internal Methods

function _introCallback(response)
	if ( response == 1 ) then
		_startFight();
	end
	
	if ( response == 2 ) then
		_showSecondPage();
	end		
end


function _secondPageCallback(response)
	if ( response == 1 ) then
		_startFight();
	end
	
	if ( response == 2 ) then
		hudPrint("Do something with cheese.");
		_destroyOgre();
		isDone = true;
	end
end


function _startFight() 
	local ogre = findEntity("dialogue_demo_ogre");
	
	if ( ogre ) then
		ogre.brain:enable();
		isDone = true;
	end
end


function _destroyOgre()
	local ogre = findEntity("dialogue_demo_ogre");
	
	if ( ogre ) then
		damageTile(ogre.level, ogre.x, ogre.y, ogre.facing, ogre.elevation, 0, "physical", 99999);
		isDone = true;
	end
end


function _itemSelectCallback()
	hudPrint("Random Item Callback Demo");
end


function _showIntroPage()	
	local page = {
		speakerName = "Forest Ogre",
		speakerMessage = "'Ello Puny Adventurers. Me nice Ogre. I give you one chance. Or I kill you. Starting wif "  .. party.party:getChampion(1):getName(),
		onFinish = self.go.id..".script._introCallback",
		responses = {
			{ text = "Oh really? Bring it on!" },
			{ text = "Whatever you say. What do I have to do?" },
			{ text = "<Leave Saying Nothing>", onSelect = self.go.id..".script._itemSelectCallback" }
		}
	}

	GTKGui.Dialogue.showDialoguePage(page);
end


function _showSecondPage()
	local page = {
		speakerName = "Forest Ogre",
		speakerMessage = "Well. You give me cheese and I leave. Uvver-wise, me kill you.",
		onFinish = self.go.id..".script._secondPageCallback",
		responses = {
			{ text = "Screw this. We're just going to kill you ourselves!" },
			{ text = "Take our cheese Mr Ogre!" },
			{ text = "<Leave Saying Nothing>" }
		}
	}

	GTKGui.Dialogue.showDialoguePage(page);
end

