
------------------------------------------------------------------------
-- Dialogue Example 2
--
-- An example of a simple dialogue using targets/callbacks on scripts.
------------------------------------------------------------------------


isDone = false;
shownOnce = false;
gotTreasure = false;

function fight()
	local ratling = findEntity("dialogue_demo_ratling");
	
	if ( ratling ) then
		ratling.brain:enable();
	end
	
	isDone = true;
end


function treasure()
	setMouseItem(spawn("cheese").item);
	isDone = true;
end


function showDemoDialogue(sender)
	if ( isDone == true ) then
		return;
	end

	local startPage = nil;

	if ( shownOnce == false ) then
		startPage = "first";
		shownOnce = true;
	else 
		startPage = "return";
	end


	local dialogue = {
		lockParty = true,
		startPage = startPage,
		pages = {
			{
				id = "first",
				speakerName = "Ratling",
				speakerMessage = "Ssss-ooooooo. Why have you sssscum intruded our dungeon?",
				responses = {
					{ text = "We're here to kill you actually...", nextPage = "fight" },
					{ text = "If you give us some treasure we'll let you live.", nextPage = "treasure" },
					{ text = "Oh, you know. We're just passing by.", nextPage = "goodbye" },					
				} 
			},
			{
				id = "return",
				speakerName = "Ratling",
				speakerMessage = "You have returned eh? C'Mon, hurry up!",
				responses = {
					{ text = "We're here to kill you actually...", nextPage = "fight" },
					{ text = "If you give us some treasure we'll let you live.", nextPage = "treasure" },
					{ text = "Oh, you know. We're just passing by.", nextPage = "goodbye" },					
				} 
			},
			{
				id = "fight",
				speakerName = "Ratling",
				speakerMessage = "Very well. If you wantsss to die, then we sssshall fight!",
				responses = {
					{ text = "Okay", onSelect = self.go.id .. ".script.fight" },
				}
			},
			{
				id = "treasure",
				speakerName = "Ratling",
				speakerMessage = "Here. Ssssome Cheese. My greatest treasssure!",
				responses = {
					{ text = "Thanks.", onSelect = self.go.id .. ".script.treasure" },
				}
			},
			{
				id = "goodbye",
				speakerName = "Ratling",
				speakerMessage = "Well, I'll be kicking back here in demo land if you change your mind later.",
				responses = {
					{ text = "<Leave>" },
				}
			},			
		}
	}

	GTKGui.Dialogue.startDialogue(dialogue);
end

function hideDemoDialogue()
	GTKGui.Dialogue.hideDialogue();
end