
------------------------------------------------------------------------
-- Dialogue Example 3
--
-- An example of a dialogue system which uses the top box to present
-- more information to the player.
------------------------------------------------------------------------

function gtkDidLoad()
	GTK.Core.GUI:addImage({ name="book-of-monsters", path="mod_assets/ext/grimtk/samples/book-of-monsters.tga", size={545, 400} });
end

isDone = false;

function biteParty()
	local champion = party.party:getChampion(1);
	champion:damage(10, "physical");
	playSound("consume_food");
	champion:playDamageSound();
end

function enableBook()
	local e = findEntity("book_of_monsters");

	if ( e ) then
		e.item:enable();
		e.item:setUiName("Book of Monsters!");
		isDone = true;
	end
end

function showDemoDialogue(sender)
	if ( isDone == true ) then
		return;
	end

	local dialogue = {
		lockParty = true,
		pages = {
			{
				id = "first",
				mainImage = "book-of-monsters",
				speakerMessage = "A small book lies still on an altar behind the bars...",
				playSound = "polymorph_bear",
				responses = {
					{ text = "<Poke It>", nextPage = "poke", onSelect = self.go.id..".script.biteParty" },
					{ text = "<Stare At It>", nextPage = "stare" },
					{ text = "<Walk Away>" },					
				} 
			},
			{
				id = "poke",
				mainImage = "book-of-monsters",
				mainMessage = "*Gnash* *Gnash* *Gnash*",
				responses = {
					{ text = "Okay...", nextPage = "first" },
				}
			},
			{
				id = "stare",
				mainImage = "book-of-monsters",
				mainMessage = "WHAD YA WANT?",
				responses = {
					{ text = "To read you!", nextPage = "okay" },
					{ text = "<Walk Away>" }
				}
			},	
			{
				id = "okay",
				mainImage = "book-of-monsters",
				mainMessage = "OKAY THEN!",
				responses = {
					{ text = "<Done>", onSelect = self.go.id..".script.enableBook" },
				}
			}
		}
	}

	GTKGui.Dialogue.startDialogue(dialogue);
end

function hideDemoDialogue()
	GTKGui.Dialogue.hideDialogue();
end