
g_UseORRR3Skills = true;
g_DebugSpells = true;


--
-- Most of these spells are experimental - do not expect them to be in the final mod!
--

function spDefineSpell(data)

	if g_DebugSpells == true then
		data.skill = "light"
		data.requirements = { "concentration", 1 }
	elseif ( g_UseORRR3Skills == false ) then
		if ( data.skill == "life_magic" or data.skill == "death_magic" ) then
			data.skill = "concentration"
		end

		if ( data.requirements ~= nil ) then
			local newRequirements = { };

			for _,v in pairs(data.requirements) do
				if v == "life_magic" or v == "death_magic" then
					table.insert(newRequirements, "concentration")
				else
					table.insert(newRequirements, v)
				end
			end

			data.requirements = newRequirements;
		end
	end

	local reqString = "";

	if data.requirements then
		for _,v in pairs(data.requirements) do
			reqString = reqString .. " " .. v
		end
	end

	--print("Defining: ", data.name, data.skill, reqString)
	defineSpell(data)
end



spDefineSpell{
	name = "sp_ogre_strength",
	uiName = "Ogre Strength",
	gesture = 12,
	manaCost = 30,
	skill = "life_magic",
	requirements = { "life_magic", 1, "fire_magic", 1 },
	icon = 102,
	spellIcon = 19,
	description = "Temporarily gain the strength of an Ogre.",
	onCast = function(champion, x, y, direction, elevation, skillLevel) 
		champion:setConditionValue("sp_ogre_strength", 10)
	end
}


spDefineSpell{
	name = "sp_heal_self",
	uiName = "Heal Self",
	gesture = 2,
	manaCost = 40,
	skill = "life_magic",
	requirements = { "life_magic", 2 },
	icon = 102,
	spellIcon = 19,
	description = "Restores a small amount of the caster's health at a high energy cost.",
	onCast = function(champion, x, y, direction, elevation, skillLevel) 
		champion:regainHealth(20)
	end
}


spDefineSpell{
	name = "sp_regeneration",
	uiName = "Regeneration",
	gesture = 258,
	manaCost = 60,
	skill = "life_magic",
	requirements = { "life_magic", 4 },
	icon = 102,
	spellIcon = 19,
	description = "The champion regenerates a small amount of health each second for a short amount of time.",
	onCast = function(champion, x, y, direction, elevation, skillLevel) 
		champion:setConditionValue("sp_regenerate_health", 20)
	end
}


spDefineSpell{
	name = "sp_sacrificial_cut",
	uiName = "Sacrificial Cut",
	gesture = 8,
	manaCost = 1,
	skill = "death_magic",
	requirements = { "death_magic", 1 },
	icon = 102,
	spellIcon = 19,
	description = "The champion sacrifices a small portion of their health for increased energy regeneration for a period of time.",
	onCast = function(champion, x, y, direction, elevation, skillLevel)
		if champion:getHealth() > 30 then
			champion:damage(30, "physical")
			champion:setConditionValue("sp_regenerate_energy", 20)
			return true
		end

		return false
	end
}


spDefineSpell{
	name = "sp_summon_fire_trap",
	uiName = "Fire Trap",
	gesture = 123,
	manaCost = 35,
	skill = "fire_magic",
	requirements = { "fire_magic", 2 },
	icon = 102,
	spellIcon = 19,
	description = "Draw a rune of fire on the area in front of you that will trigger a fire burst when stepped on.",
	onCast = function(champion, x, y, direction, elevation, skillLevel)
		local dx, dy = getForward(direction)
		spawn("sp_fire_trap", party.level, x+dx, y+dy, direction, party.elevation);
	end
}



