SOUND = {
	Table = {},
	Melody = {4,4,5,6,6,5,6,6,8,5,4,3,4,5},
	arrowsHit = 0,
	Index = 0,
	ok = false,
	scroll = false,
	picture = nil,
	lever = nil,
}

function Tick(sender)
	SOUND.Index = SOUND.Index + 1
--	print(SOUND.Index)
	local i
	if SOUND.Table[SOUND.Index] == nil then
		stopMelody()
		return 
	end
	if SOUND.Index == 1 then 
		SOUND.ok = true
	end
	for i = 1,#SOUND.Table[SOUND.Index] do
		local ent = findEntity(SOUND.Table[SOUND.Index][i])
		if ent then
			if ent.socket:count()==1 then
				ent.sound:play(ent.sound:getSound())
				if i ~= SOUND.Melody[SOUND.Index] then SOUND.ok = false end
			elseif i == SOUND.Melody[SOUND.Index] then SOUND.ok = false end
		end
	end
--	Conditions in 7th note
	if SOUND.Index == 7 then
		if SOUND.ok == false then 
			stopMelody()
			at_archer_door_left.door:open()
		else 
			if at_archer_door_left.door:isOpen() == false then expToParty(100) end
			at_breath_spawner_2.spawner:activate("at_demon_breath")
			at_dungeon_secret_left.door:open() 
			at_tomb_secret_door_left.door:open()
			at_archer_door_left.door:open()
		end
	end
--	Conditions in 14th note -> full song test
	if SOUND.Index == 14 then
		if SOUND.ok == false then 
			stopMelody()
			at_archer_door_right.door:open()
		else 
			if at_archer_door_right.door:isOpen() == false then
				expToParty(100) 
				local ped = findEntity("at_reward_pedestal")
				ped.surface:addItem(spawn("at_reward_arrow").item)
				ped.surface:addItem(spawn("or3_ore_meteorite").item)
				local FX = ped:createComponent("Particle")
				FX:setParticleSystem("wall_fire_impact")
				FX:setOffset(vec(0,1,0))
				FX:setDestroySelf(true)
				FX:start()
				playSound("fireburst",ped.level,ped.x,ped.y)--discover_spell
			end
			at_dungeon_secret_right.door:open()
			at_tomb_secret_door_right.door:open()
			at_archer_door_right.door:open()
		end
	end
end

function startMelody(sender)
	sender.go.clickable:disable()
	SOUND.lever = sender.go.id
end
function stopMelody()
	at_melody_timer.timer:stop()
	SOUND.Index = 0
	SOUND.ok = false
	local lever = findEntity(SOUND.lever)
	if lever then 
		lever.clickable:enable() 
		lever.lever:setState("deactivated")
		SOUND.lever = nil
	end
end

function arrowHit(entity)
	if SOUND.arrowsHit < 5 then
		SOUND.arrowsHit = SOUND.arrowsHit+1
		entity.surface:addItem(spawn("at_ceremonial_arrow").item)
		if entity.arrowparticle ~= nil then 
			entity:removeComponent("arrowparticle") 
		end
--		spawner_3.spawner:activate()
		local FX = entity:createComponent("Particle","arrowparticle")
		FX:setParticleSystem("lightning_bolt_hit")
		FX:setOffset(vec(0,1,0))
		FX:setDestroySelf(true)
		FX:start()
		playSound("blow_horn",entity.level,entity.x,entity.y)
		expToParty(math.floor(100/SOUND.arrowsHit))
	end
end

function expToParty(expy)
	local ch
	for i = 1,4 do
		ch = party.party:getChampion(i)
		if ch and ch:getEnabled() and ch:isAlive() then
			ch:gainExp(expy)
		end
	end
end

function getBackArrow(count)
	local ca = spawn("at_ceremonial_arrow")
	ca.item:setStackSize(count)
	setMouseItem(ca.item)
end

function InsertArrow()
	local i,j,k,v
	local startArrows = {4}
--	local startArrows = SOUND.Melody
	for k,v in pairs(startArrows) do
		local ent = findEntity(SOUND.Table[k][v])
		if ent then
			ent.socket:addItem(spawn("at_ceremonial_arrow").item)
		end
	end
end

function placeSounds(x,y,d,px,i)
	local ST = {"_C_","_D_","_E_","_F_","_G_","_A_","_H_","_C2_"}
	SOUND.Table[i]={}
	for j = 1, #ST do
		local name = "at_arrowSocket_"..i..ST[j]
		local alc = findEntity(name)
		if alc == nil then 
			alc = spawn("at_soundArrowSocket",2,x,y,d,0,name)
			at_Positions.script.manage_positions(name,px,(0.2*j)+0.5,-0.5)
			table.insert(SOUND.Table[i],name)
		end
	end
end

function onPictureClick(pic)
	local mi = getMouseItem()
	if mi then 
		local mo = mi.go
--		print(mo.name) 
		if mo.name == "scroll" and SOUND.scroll == false then
			SOUND.scroll = true
			SOUND.picture = mo.scrollitem:getScrollImage()--ScrollItemComponent
			playSound("read_scroll")
			if SOUND.picture == nil then 
				pic.go.model:setMaterialOverrides({dm_portrait_glass = "at_scroll_blank"})
			else
				pic.go.model:setMaterialOverrides({dm_portrait_glass = "at_scroll_melody"})
			end
			setMouseItem(nil)
		end
		if mo.name == "torch" and SOUND.scroll == true and SOUND.picture == nil then
			pic.go.model:setMaterialOverrides({at_scroll_blank = "dm_portrait_glass"})
			pic.go.model:setMaterialOverrides({dm_portrait_glass = "at_scroll_melody"})
			SOUND.picture = "mod_assets/rooms/at/textures/scroll_small_melody.tga"
			playSound("scramble_writer")
			expToParty(200)
		end
	else 
--		print("free hand") 
		if SOUND.scroll == true then
			local mo = spawn("scroll")
			playSound("read_scroll")
			if SOUND.picture then 
				mo.scrollitem:setScrollImage(SOUND.picture) 
				pic.go.model:setMaterialOverrides({at_scroll_melody = "dm_portrait_glass"})
			else
				pic.go.model:setMaterialOverrides({at_scroll_blank = "dm_portrait_glass"})
			end
			setMouseItem(mo.item)
			SOUND.scroll = false
			SOUND.picture = nil
		end
	end
end

function onTapestryClick(tape)
	if party.x == tape.go.x and party.y == tape.go.y then
		local torn = tape.go:spawn("castle_wall_cloth_torn")
		at_Positions.script.manage_positions(torn.id,0,0,-0.1)
		tape.go:destroy()
		playSound("wall_tapestry_tear")
	end
end

function removeArrows(sender)
	local item = "at_ceremonial_arrow"
	local i,j,entity
	local arrCount = 0
	local mi = getMouseItem()
-- remove from Mouse
	if mi and mi.go.name == item then
		setMouseItem(nil)
		at_knight_sarcophagus_1.surface:addItem(mi.go.item)
		arrCount = arrCount + mi.go.item:getStackSize()
	end
-- remove from Floor	
	local fi
	for fi in sender.go.map:entitiesAt(sender.go.x, sender.go.y) do
		if fi.name == item then
			arrCount = arrCount + fi.item:getStackSize()
			at_knight_sarcophagus_1.surface:addItem(fi.item)
		else
			if fi.containeritem ~= nil then
				local box = fi.containeritem
				for a = 1,box:getCapacity() do
					local iitem = box:getItem(a)
					if iitem  ~= nil and iitem.go.name == item then
						box:removeItem(a)
						at_knight_sarcophagus_1.surface:addItem(fi.item)
						arrCount = arrCount + fi.item:getStackSize()
					end
				end
			end
		end
	end
-- remove from Champions
	for i = 1,4 do
		local champion = party.party:getChampion(i)
		for j = 1,31 do
			local entity = champion:getItem(j)
			if entity ~= nil then
				if entity.go.name == item then
--					editItem(entity.go,val)
					champion:removeItemFromSlot(j)
					at_knight_sarcophagus_1.surface:addItem(entity.go.item)
					arrCount = arrCount + entity.go.item:getStackSize()
				end
				if entity.go.containeritem ~= nil then
					local box = entity.go.containeritem
					for a = 1,box:getCapacity() do
						local iitem = box:getItem(a)
						if iitem  ~= nil and iitem.go.name == item then
--							editItem(iitem.go,val)
							box:removeItem(a)
							at_knight_sarcophagus_1.surface:addItem(entity.go.item)
							arrCount = arrCount + entity.go.item:getStackSize()
						end
					end
				end
			end
		end
	end
	if arrCount > 0 then
		hudPrint("Ceremonial arrows must stay in heroes tomb.")
		hudPrint("All this arrows are returned back to sarcophagus.")
	end
end

function createSounds()
	placeSounds(15,4,1,0.7,1)
	placeSounds(15,4,1,-0.7,2)
	placeSounds(15,5,1,0.7,3)
	placeSounds(15,5,1,-0.7,4)
	placeSounds(15,6,1,0.7,5)
	placeSounds(15,6,1,-0.7,6)
	placeSounds(15,7,1,0.7,7)
	placeSounds(13,4,3,-0.7,8)
	placeSounds(13,4,3,0.7,9)
	placeSounds(13,5,3,-0.7,10)
	placeSounds(13,5,3,0.7,11)
	placeSounds(13,6,3,-0.7,12)
	placeSounds(13,6,3,0.7,13)
	placeSounds(13,7,3,-0.7,14)
end

function setPositions()
	createSounds()
	at_Positions.script.manage_positions("at_dm_portrait_sound_1",0,0,0.08)
	at_Positions.script.manage_positions("at_castle_wall_cloth_1",0,0,-0.1)
	delayedCall(self.go.id,0.1,"InsertArrow")
end

delayedCall(self.go.id,0.01,"setPositions")