-- This file has been generated by Dungeon Editor 2.2.4

-- TODO: place your custom dungeon object definitions here

defineObject{
	name = "at_casle_wallpillar_left",
	baseObject = "base_wall_decoration",
	components = {
		{
			class = "Model",
			model = "mod_assets/rooms/at/models/env/casle_pillar_L.fbx",
		},
	},
	editorIcon = 92,
	minimalSaveState = false,
}
defineObject{
	name = "at_casle_wallpillar_right",
	baseObject = "base_wall_decoration",
	components = {
		{
			class = "Model",
			model = "mod_assets/rooms/at/models/env/casle_pillar_R.fbx",
		},
	},
	editorIcon = 92,
	minimalSaveState = false,
}


defineObject{
	name = "at_soundArrowSocket",
	components = {
		{
			class = "Model",
			model = "mod_assets/rooms/at/models/env/trap.fbx",
		},
		{
			class = "Clickable",
			offset = vec(0, 0, -0.15),
			size = vec(0.15, 0.15, 0.15),
			maxDistance = 1,
			frontFacing = true,
--			debugDraw = true,
		},
		{
			class = "Socket",
			offset = vec(0, 0, 0),
			rotation = vec(0, 90, 0),
			onAcceptItem = function(self, item)
				local sn = self.go.sound:getSound()
				return (( item.go.name == "at_ceremonial_arrow") and self:count() == 0 )--true --
			end,
			onInsertItem = function(self, item)
				local stack = item:getStackSize()
				if stack > 1 then 
					item:setStackSize(1)
					delayedCall("at_melody_sc",0.1,"getBackArrow",stack-1)
				end
			end,
--			debugDraw = true,
		},
		{
			class = "Sound",
			sound = "tone_A",
		},
		{
			class = "Null",
			onInit = function(self)
				local SL = {"C","D","E","F","G","A","H","C2"}
				self.go.sound:disable()
				local offs = 0
				if string.find(self.go.id, "_C2_") then offs = 8
				elseif string.find(self.go.id, "_C_") then offs = 1
				elseif string.find(self.go.id, "_D_") then offs = 2
				elseif string.find(self.go.id, "_E_") then offs = 3
				elseif string.find(self.go.id, "_F_") then offs = 4
				elseif string.find(self.go.id, "_G_") then offs = 5
				elseif string.find(self.go.id, "_A_") then offs = 6
				elseif string.find(self.go.id, "_H_") then offs = 7 end
				self.go.socket:setOffset(vec(0,-0.03,-0.7+offs*0.06))
				self.go.sound:setSound("tone_"..SL[offs])
				self.go.sound:setVolume(30)
			end,
		},
	},
	placement = "wall",
	editorIcon = 84,
	minimalSaveState = false,
}


defineObject{
	name = "at_knight_sarcophagus_light",
	baseObject = "base_altar",
	components = {
		{
			class = "Model",
			model = "mod_assets/rooms/at/models/env/plateSarcophagus_light.fbx",
			staticShadow = true,
		},
		{
			class = "Obstacle",
		},
		{
			class = "Surface",
			offset = vec(0.6, 0.6, 0),
			size = vec(0.7, 1),
--			debugDraw = true,
		},
	},
	placement = "floor",
	automapIcon = 152,
	editorIcon = 52,
}

defineObject{
	name = "at_knight_sarcophagus",
	baseObject = "base_altar",
	components = {
		{
			class = "Model",
			model = "mod_assets/rooms/at/models/env/plateSarcophagus_dark.fbx",
			staticShadow = true,
		},
		{
			class = "Obstacle",
		},
		{
			class = "Surface",
			offset = vec(0.6, 0.6, 0),
			size = vec(0.7, 1),
--			debugDraw = true,
		},
	},
	placement = "floor",
	automapIcon = 152,
	editorIcon = 52,
}

defineObject{
	name = "at_dm_portrait_sound",
	components = {
		{
			class = "Model",
			model = "mod_assets/rooms/at/models/env/dm_portrait_nothing.fbx",
		},
		{
			class = "Clickable",
			offset = vec(0, 1.8, -0.02),
			size = vec(0.9, 0.9, 0.1),
			maxDistance = 1,
			onClick = function(self)
				if at_melody_sc then at_melody_sc.script.onPictureClick(self) end
			end,
--			debugDraw = true,
		},
	},
	placement = "wall",
	editorIcon = 84,
	minimalSaveState = false,
}

defineObject{
	name = "at_dm_portrait",
	components = {
		{
			class = "Model",
			model = "mod_assets/rooms/at/models/env/dm_portrait_nothing.fbx",
		},
	},
	placement = "wall",
	editorIcon = 84,
	minimalSaveState = false,
}

defineObject{
	name = "at_castle_wall_cloth",
	baseObject = "base_wall_decoration",
	components = {
		{
			class = "Model",
			model = "assets/models/env/castle_wall_cloth.fbx",
		},
		{
			class = "Clickable",
			offset = vec(0, 1.7, -0.1),
			size = vec(1.3, 2.2, 0.1),
			maxDistance = 1,
			onClick = function(self)
--				print("tapestry click")
				if at_melody_sc then at_melody_sc.script.onTapestryClick(self) end
			end,
--			debugDraw = true,
		},
	},
}
