elevator_ascend_timer.timer:stop();
elevator_descend_timer.timer:stop();
rsg_timer.timer:stop();

function MoveBridge()

	local mbridge1 = findEntity("az_mbridge_z1");
	local mbridge2 = findEntity("az_mbridge_z2");	
	
	local mbridge3 = findEntity("az_mbridge_z3");
	local mbridge4 = findEntity("az_mbridge_z4");
	
	local mbridge5 = findEntity("az_mbridge_z5");
	local mbridge6 = findEntity("az_mbridge_z6");
	
	if mbridge1 ~= nil then
		
		local leftC = az_bridge_ctr_l.counter:getValue();
		local rightC = az_bridge_ctr_r.counter:getValue();
		
		
		-- initialize
		mbridge1.controller:deactivate();
		mbridge2.controller:deactivate();	
		mbridge3.controller:deactivate();
		mbridge4.controller:deactivate();	
		mbridge5.controller:deactivate();
		mbridge6.controller:deactivate();
		
		
		-- activate SEast
		if leftC == 0 and rightC == 1 then
			mbridge1.controller:activate();
			mbridge2.controller:activate();	
			mbridge5.controller:activate();
			mbridge6.controller:activate();
		end
		
		-- activate SWest
		if leftC == 1 and rightC == 0 then
			mbridge1.controller:activate();
			mbridge2.controller:activate();	
			mbridge3.controller:activate();
			mbridge4.controller:activate();		
		end
		
		-- activate South only
		if leftC == 0 and rightC == 0 then
			mbridge1.controller:activate();
			mbridge2.controller:activate();		
		end
		
		-- turn off hidden bridge
		if leftC == 1 and rightC == 1 then
			az_mbridge_3.controller:deactivate();
		else

			az_mbridge_3.controller:activate();	
		end
		
	end

end

function DisableEntPort()

	az_inv_teleporter_1.controller:deactivate();
end


function GetRedGem()
		
	for v,item in az_dungeon_alcove_2.surface:contents() do		
    	if item.go.id == "az_gem_red" then
			az_red_counter.counter:increment();
			playSound("discover_spell");
			
			az_red_text.walltext:setWallText(RedGemText());			
			
			CalcGems();
			
			-- at the end, destroy the gem
			item.go:destroy();		
		end
	end

end


function RedGemText()

	local wallText = 'My Red Gem, returned...'
	wallText = wallText .. '\n'
	wallText = wallText .. 'long lost relic.'
	wallText = wallText .. '\n'
	wallText = wallText .. 'At the top is what you seek.'
	
	return wallText;
end


function GetBlueGem()
		
	for v,item in az_dungeon_alcove_1.surface:contents() do		
    	if item.go.id == "az_gem_blue" then
			az_blue_counter.counter:increment();
			playSound("discover_spell");
			
			az_blue_text.walltext:setWallText(BlueGemText());			
			
			CalcGems();
			
			-- at the end, destroy the gem
			item.go:destroy();		
		end
	end
	
end


function BlueGemText()

	local wallText = 'Yes! Thank you, thank you!'
	wallText = wallText .. '\n'
	wallText = wallText .. 'A great reward...'
	wallText = wallText .. '\n'
	wallText = wallText .. 'awaits you, above...'
	
	return wallText;
end


function CalcGems()

	if (az_blue_counter.counter:getValue() + az_red_counter.counter:getValue() >= 2) then
		az_door_spear_1.door:open();
	end

end
