function lowerPlatform()
	local y = mech_elevator:getWorldPositionY()
	local level = mech_elevator.level	
	local px = mech_elevator.x
	local py = mech_elevator.y
	local face = mech_elevator.facing
	
	elevator_ascend_timer.timer:stop() -- Lets not do both at once
	
	y = y - 0.01
	
	local y = mech_elevator:getWorldPositionY()
	local level = mech_elevator.level	
	local px = mech_elevator.x
	local py = mech_elevator.y
	local face = mech_elevator.facing
	
	elevator_ascend_timer.timer:stop() -- Lets not do both at once
	
	y = y - 0.01

	
	if y <= -6 then -- Stop the elevator
		y = -6
		elevator_descend_timer.timer:stop();
		mech_elevator_field.controller:deactivate();
		
		if(party.x == 13 and party.y == 26) then
			--party:setPosition(party.x, party.y, party.facing, -2, party.level);
		end
	end
	
	mech_elevator:setWorldPositionY(y)
	
	for obj in mech_elevator.map:entitiesAt(px,py) do		
		if obj.id == "mech_elevator_field" then			
			if (math.abs(obj:getWorldPositionY()-y)<0.5) then
				obj:setWorldPositionY(y-0.01)
			end
		end
	end
	
	if y == -6 then
		OpenHiddenDoor();
	end
end

function raisePlatform()
	local y = mech_elevator:getWorldPositionY()
	local level = mech_elevator.level	
	local px = mech_elevator.x
	local py = mech_elevator.y
	local face = mech_elevator.facing
	local weMoved = 0;
	
	elevator_descend_timer.timer:stop() -- Lets not do both at once
	
	y = y + 0.01

	if y>=0 then -- Stop the elevator
		y=0
		elevator_ascend_timer.timer:stop();
		mech_elevator_field.controller:deactivate();
	end
	
	mech_elevator:setWorldPositionY(y)
	
	-- However, we also have to adjust the position of everything in this square
	-- Otherwise things will fall through the platform
	-- We might also want to adjust only things near the platform's level
	-- so that e.g. you can hide under an elevator tile.
	for obj in mech_elevator.map:entitiesAt(px,py) do
		if obj.gravity then -- Only move things that would be lifted
			if (math.abs(obj:getWorldPositionY()-y)<0.5) then			
				obj:setWorldPositionY(y+0.01)
			end
		end
		
		if obj.id == "mech_elevator_field" then			
			if (math.abs(obj:getWorldPositionY()-y)<0.5) then
				obj:setWorldPositionY(y+0.01)
			end
		end
	end
	
	if y == 0 then -- we have stopped
		if(party.x == 13 and party.y == 26 and party.elevation == 0) then		
			--party:setPosition(party.x, party.y, party.facing, 0, party.level);	
		end
		thrd_flr_bridge.controller:activate();
		DisablePlatform();
	end
end

function ResetElevator()

	local mPlatform = findEntity("mech_elevator");
	local mField = findEntity("mech_elevator_field");

	if mPlatform ~= nil then
		mech_elevator:setPosition(mPlatform.x, mPlatform.y, mPlatform.facing, -2, party.level);
	end
	
	if mField ~= nil then
		mech_elevator_field:setPosition(mField.x, mField.y, mField.facing, -2, party.level);
	end	
	
	-- initialize top controls
	
	local mbridge1 = findEntity("az_mbridge_z1");
	local mbridge2 = findEntity("az_mbridge_z2");	
	
	local mbridge3 = findEntity("az_mbridge_z3");
	local mbridge4 = findEntity("az_mbridge_z4");
	
	local mbridge5 = findEntity("az_mbridge_z5");
	local mbridge6 = findEntity("az_mbridge_z6");
		
	mbridge1.controller:activate();
	mbridge2.controller:activate();
	
	mbridge3.controller:deactivate();
	mbridge4.controller:deactivate();	
	mbridge5.controller:deactivate();
	mbridge6.controller:deactivate();
	
	az_mbridge_lv_1.lever:setState("deactivated");
	az_mbridge_lv_2.lever:setState("deactivated");
	
	az_bridge_ctr_l.counter:setValue(0)
	az_bridge_ctr_r.counter:setValue(0)
end


function CloseHiddenDoor()

	azel_sec_door_1.door:close();
	
end

function OpenHiddenDoor()

	azel_sec_door_1.door:open();
	thrd_flr_bridge.controller:activate();
end


function CanRaiseElevator()

	if mech_elev_pwr_tmr.counter:getValue() >= 1 then
		mech_elevator_field.controller:activate();
		thrd_flr_bridge.controller:deactivate();
		
		CloseHiddenDoor();
		
		elevator_ascend_timer.timer:start();
	else
		playSound("error_beep");
	end

end

function DelayLowerElevator()

	playSound("set_go_beep");
end

function EnablePlatform()
	mech_elevator.platform:enable();
end
function DisablePlatform()
	mech_elevator.platform:disable();
end

function PowerOn()
	az_power_text.walltext:setWallText("Power Source: 100");
end

function PowerOff()
	az_power_text.walltext:setWallText("Power Source: 0");
end
