-- This file has been generated by Dungeon Editor 2.2.4

-- TODO: place your custom dungeon object definitions here


defineObject{
	name = "dc_pushable_rock",
	baseObject = "pushable_block",
	components = {
		{
			class = "Model",
			model = "assets/models/env/beach_rock_1x1_01.fbx",
		},

	},
}

defineObject{
	name = "dc_pushable_block_floor_invisible",
	baseObject = "base_floor_decoration",
	components = {
		{
			class = "Model",
			model = "assets/models/env/pushable_block_floor01.fbx",
			staticShadow = true,
		},
		{
			class = "PushableBlockFloor",
			name = "controller",
		},
	},
	editorIcon = 224,
	replacesFloor = true,
}

defineObject{
	name = "sx_winter_rope_ladder",
	baseObject = "base_wall_decoration",
	components = {
		{
			class = "Model",
			model = "mod_assets/rooms/duncan/models/sx_winter_rope_ladder.fbx",
			--offset = vec(0,0,-0.4),
		},
		{
			class = "Animation",
			animations = {
				sway = "mod_assets/rooms/duncan/animations/sx_ropeladder_idle.fbx",
			},
			playOnInit = "sway",
			loop = true,
		},
		{
			class = "Ladder",
		},
		{
			class = "Clickable",
			offset = vec(0, 1.6, -0.4),
			size = vec(0.8, 1.6, 0.4),
			frontFacing = true,
			--debugDraw = true,
		},
	},
	editorIcon = 248,
	automapIcon = 140,
}

defineObject{
	name = "dc_central_pillar",
	baseObject = "base_floor_decoration",
	components = {
		{
			class = "Model",
			model = "mod_assets/sx_urban_town/models/sx_house01_pillar_wooden_2h.fbx",
			staticShadow = true,
		}
	},
	minimalSaveState = true,
}



defineObject{
	name = "dc_beacon_balance",
	baseObject = "base_pillar",
	components = {
		{
			class = "Model",
			model = "assets/models/env/elemental_holder_balance.fbx",
			staticShadow = true,
		},
		{
			class = "Light",
			offset = vec(0, 1.2, -1.1),
			range = 6,
			color = vec(0.4, 0.5, 1),
			brightness = 8,
			castShadow = false,
			staticShadows = false,
			--fadeOut = 0,
			onUpdate = function(self)
				local socket = self.go.socket
				if socket:count() > 0 then
					local it = socket:getItem()
					if it.go.name == "essence_balance" then
						it.go:setWorldPositionY(0.85 + math.sin(Time.currentTime()) * 0.05)
					elseif it:hasTrait("essence") then
						it.go:setWorldPositionY(0.75)
					end
				end
			end,
		},
		-- {
		-- 	class = "Sound",
		-- 	sound = "essence_ambient",
		-- 	fadeOut = 0,
		-- },
		{
			class = "Socket",
			offset = vec(0, 0.85, -1.1),
			onAcceptItem = function(self, item)
				return self:count() == 0
			end,
			onInsertItem = function(self, item)
				if item.go.name == "essence_balance" then
					self.go.light:fadeIn(1)
					self.go.sound:fadeIn(1)
				end
			end,
			onRemoveItem = function(self, item)
				if item.go.name == "essence_balance" then
					self.go.light:fadeOut(1)
					self.go.sound:fadeOut(1)
				end
			end,
			--debugDraw = true,
		},
		{
			class = "Clickable",
			offset = vec(0, 0.8, -1.1),
			size = vec(2.9, 0.8*2, 2.9),
			maxDistance = 1,
			-- debugDraw = true,
			},
			{
			class = "Surface",
			offset = vec(0, 0.8, -1.1),
			size = vec(2.7, 2.7),
			-- debugDraw = true,
			},
	},
	placement = "pillar",
	--editorIcon = 88,
}

defineObject{
	name = "or3_ghost_remains",
	baseObject = "remains_of_toorum",
	components = {
			{
			class = "Item",
			uiName = "Ghost Remains",
			description = "Long ago decayed remains of a human. The bones have a strange aura.",
			gfxIndex = 212,
			weight = 5.0,
			},
		},
}

defineObject{
	name = "dc_stone_floor",
	baseObject = "base_pillar",
	components = {
		{
			class = "Model",
			model = "assets/models/env/forest_ruins_ceiling_flat.fbx",
			staticShadow = true,
		},
	},
	editorIcon = 164,
	minimalSaveState = true,
	placement="pillar",
}

defineObject{
	name = "dc_power_gem",
	baseObject = "power_gem",
	components = {
		{
			class = "Clickable",
			offset = vec(0.0, 1.2, 0),
			size = vec(0.25, 0.25, 0.25),
			maxDistance = 1,
			--debugDraw = true,
			onClick = function(self)
				local hight=dc_beacon_balance_1.elevation
				if getMouseItem() == nil then
					local item = self.go:spawn("power_gem_item")
					setMouseItem(item.item)
				if hight==0  then dc_beacon_balance_1.surface:addItem(spawn("or3_ghost_remains").item)
				end
				if hight>=1 then
				dc_down_timer.timer:start()
				end
				self.go:destroy()
				end
			end,
		},
	},
}

defineObject{
	name = "dc_floor_trigger",
	baseObject = "floor_trigger",
	components = {
			{
			class = "Light",
			offset = vec(0, 0, 0),
			range = 3,
			color = vec(0.2, 0.5, 1),
			brightness = 35,
			enabled = false,
			fillLight = true,
		},
		{
			class = "Particle",
			particleSystem = "pushable_block_white",
			emitterMesh = "assets/models/env/pushable_block_floor_light.fbx",
			disableSelf = true,
			enabled = false,
		},
	},
	placement = "floor",
	editorIcon = 140,
}

defineObject{
	name = "dc_water_surface_underground",
	baseObject = "base_floor_decoration",
	components = {
		{
			-- updates global reflection and refraction maps
			class = "WaterSurface",
			planeY = 0.1,
			fogColor = math.saturation(vec(0.042, 0.09, 0.26), 0.5) * 0.5,
			fogDensity = 0.2,
			reflectionColor = vec(0.77, 0.9, 1.0) * 0.9,
			refractionColor = vec(1,1,1),
		},
		{
			-- builds a continuous mesh from underwater tiles
			class = "WaterSurfaceMesh",
			material = "water_surface_calm",
			underwaterMaterial = "water_surface_underwater",
			offset = vec(0, 0.1, 0),
		},
	},
	dontAdjustHeight = true,
	editorIcon = 264,
}

defineObject{
	name = "dc_pushable_block_floor",
	baseObject = "pushable_block_floor_trigger",
	components = {
		{
			class = "Light",
			offset = vec(0, 1, 0),
			range = 3,
			color = vec(1, 0.35, 0.2),
			brightness = 35,
			enabled = false,
			fillLight = true,
		},
		{
			class = "Particle",
			particleSystem = "pushable_block_white",
			emitterMesh = "assets/models/env/pushable_block_floor_light.fbx",
			disableSelf = true,
			enabled = false,
		},
		{
			class = "PushableBlockFloor",
			name = "controller",
		},
	},
	editorIcon = 224,
	replacesFloor = true,
}

defineObject{
	name = "dc_rock_red",
	baseObject = "rock",
	components = {
		{
			class = "Model",
			model = "mod_assets/rooms/duncan/models/dc_rockred.fbx",
		},
	},
}

defineObject{
	name = "dc_rock_green",
	baseObject = "rock",
	components = {
		{
			class = "Model",
			model = "mod_assets/rooms/duncan/models/dc_rockgreen.fbx",
		},
	},
}

defineObject{
	name = "dc_rock_red_used",
	baseObject = "rock",
	components = {
		{
			class = "Model",
			model = "mod_assets/rooms/duncan/models/dc_rockred_used.fbx",
		},
	},
}

defineObject{
	name = "dc_rock_green_used",
	baseObject = "rock",
	components = {
		{
			class = "Model",
			model = "mod_assets/rooms/duncan/models/dc_rockgreen_used.fbx",
		},
	},
}

defineObject{
	name = "dc_forest_statue_pillar_03",
	baseObject = "forest_statue_pillar_03",
	components = {
		
	},
	minimalSaveState = true,
	placement="floor",
	editorIcon = 100,
}

defineObject{
	name = "dc_forest_underwater_bubbles",
	components = {
		{
			class = "Particle",
			particleSystem = "dc_forest_underwater_bubbles"
		},
	},
	placement = "floor",
	editorIcon = 88,
}

defineObject{
	name = "dc_town_stone_counter",
	components = {
	   {
	      class = "Model",
	      model = "mod_assets/rooms/duncan/models/dc_town_table_stone.fbx",
	      offset = vec(0, 0 + 0, -1.3,0),
	      staticShadow = true,
	   },
	   {
			class = "Surface",
			offset = vec(0, 0.88, -0.5),
			size = vec(2.1, -2.8),
			--debugDraw = true,
		},
		{
			class = "Clickable",
			offset = vec(0, 0.88, -0.5),
			size = vec(2.1, 0.88*2, 1.2),
			maxDistance = 1,
			--debugDraw = true,
		},
		
	},
	replacesWall = false,
	placement = "wall",
	editorIcon = 92,
}

defineObject{
	name = "dc_invisible_wall_blocker",
	baseObject = "base_door_sparse",
	components = {
	   {
	      class = "Model",
	      model = "mod_assets/rooms/duncan/models/dc_blocker.fbx",
	      staticShadow = true,
	   },
	   --{
	   --   class = "Door",
	   --   hitSound = "impact_blunt",
	 --  },
	},
	placement = "wall",
	editorIcon = 160,
	automapIcon = 88,
}

defineObject{
		name = "dc_duel_mark",
		baseObject = "base_item",
		components = {
		{
			class = "Model",
			model = "mod_assets/rooms/duncan/models/dc_duel_mark.fbx",
		},
		{
			class = "Item",
			uiName = "Duel Pass",
			gfxAtlas = "mod_assets/rooms/duncan/textures/dc_runesicons.dds",
			gfxIndex=7,
			weight = 0.2,

		},
	},
}
defineObject{
		name = "dc_fire_mark",
		baseObject = "base_item",
		components = {
		{
			class = "Model",
			model = "mod_assets/rooms/duncan/models/dc_fire_mark.fbx",
		},
		{
			class = "Item",
			uiName = "Fire Pass",
			gfxAtlas = "mod_assets/rooms/duncan/textures/dc_runesicons.dds",
			gfxIndex=0,
			weight = 0.2,

		},
	},
}
defineObject{
		name = "dc_water_mark",
		baseObject = "base_item",
		components = {
		{
			class = "Model",
			model = "mod_assets/rooms/duncan/models/dc_water_mark.fbx",
		},
		{
			class = "Item",
			uiName = "Water Pass",
			gfxAtlas = "mod_assets/rooms/duncan/textures/dc_runesicons.dds",
			gfxIndex=8,
			weight = 0.2,

		},
	},
}

defineObject{
	name = "dc_pillar_button",
	components = {
			{
			class = "Model",
			model = "mod_assets/rooms/duncan/models/dc_pillar_button.fbx",
		},
		{
			class = "Clickable",
			offset = vec(-1.48,1.375,0.1),
			size = vec(0.25, 0.25, 0.25),
			--debugDraw = true,
		},
		{
			class = "Button",
			sound = "button",
		},
	},
	placement = "wall",
	editorIcon = 12,
}

defineObject{
	name = "dc_dungeon_wall_grating",
	baseObject = "base_door",
	components = {
		{
			class = "Model",
			model = "assets/models/env/dungeon_wall_grating.fbx",
			staticShadow = true,
		},
		{
			class = "Door",
			openVelocity = 1.3,
			closeVelocity = 0,
			closeAcceleration = -10,
			sparse = true,

		},
		{
			class = "Controller",
			onOpen = function(self)
				self.go.door:open()
			end,
			onClose = function(self)
				self.go.door:close()
			end,
			onToggle = function(self)
				self.go.door:toggle()
			end,
		},
	},
	editorIcon = 124,
	automapIcon = 84,
	minimalSaveState = false,
}