---------------------------
--- Cemetery Floor Fogs ---
---------------------------

defineObject{
	name = "cemetry_floor_fog_01",
	components = {
		{
		   class = "Light",
		   offset = vec(1.2, 0.2, 0),
		   range = 0,

		   color = vec(1, 1, 1),
		   --color = vec(0.67, 0.58, 13),
		   brightness = 1,
		   castShadow = true,
		   staticShadows = true,
		   onUpdate = function(self)
		   local noise = math.noise(Time.currentTime()*3 + 123) * 0.5 + 0.9
			self:setBrightness(noise * 9)
			end,
		},
		{
		   class = "Particle",
		   particleSystem = "cemetry_fog",
		},
	},
	placement = "floor",
	editorIcon = 88,
	tags = { "ew_stuff" },
}

defineParticleSystem{
	name = "cemetry_fog",
	emitters = {
		-- fog
		{
			emissionRate = 150,
         	emissionTime = 0,
         	maxParticles = 500,
        	spawnBurst = false,
        	boxMin = {-4.5, 0.0,-4.5},
        	boxMax = { 4.5, 0.0, 4.5},
        	sprayAngle = {0,360},
        	velocity = {0.0,0.0},
        	objectSpace = true,
        	texture = "assets/textures/particles/smoke_01.tga",
        	lifetime = {10,10},
        	colorAnimation = false,

			--color0 = {1, 1, 1}, = White
			color0 = {0.67, 0.58, 0.13}, -- =Green
       		opacity = 0.02,
         	fadeIn = 5,
         	fadeOut = 5,
         	size = {2.5, 2.5},
         	gravity = {0,0.01,0},
         	airResistance = 0.5,
         	rotationSpeed = 0.05,
         	blendMode = "Translucent",
		}
	}
}

----------------------------------
--- Cemetry Thunder Fx & Sound----
----------------------------------

defineObject{
	name = "el_thunder_light",
	tags = { "ew_stuff" },
	components = {
	{
	class = "Light",
	offset = vec(0, 12, 0),
	range = 30,
	color = vec(1.8, 1, 1), --1.8,1,1,--
	brightness = 80,
	castShadow = true,
	-- fillLight = true,
	fadeOut = 0.5,
	destroyObject = true,
	},
},
placement = "floor",
editorIcon = 88,
}

---Cemetery Statues---
defineObject{
	name = "el_thunder_light_blue",
	tags = { "ew_stuff" },
	components = {
		{
		class = "Light",
		offset = vec(0, 12, 0),
		range = 30,
		color = vec(0.2, 0.75, 1),
	--color = vec(1.8, 1, 1), --1.8,1,1,--
		brightness = 80,
		castShadow = true,
	-- fillLight = true,
		fadeOut = 0.5,
		destroyObject = true,
	},
},
placement = "floor",
editorIcon = 88,
}

defineSound{
	name = "el_thunder_sound_01",
	filename = {
	"mod_assets/rooms/eleven_warrior/el_thunder_03.wav",
	},
	loop = false,
	volume = 0.3,
	minDistance = 1,
	maxDistance = 10,
}

defineObject{
	name = "el_statue_fire_light",
	tags = { "ew_stuff" },
	components = {
		{
		class = "Light",
		offset = vec(0, 0, 0),
		range = 10,
		color = vec(1.3, 0.68, 0.35),
		--color = vec(0.25, 0.6, 0.5),
		brightness = 10,
		castShadow = true,
		staticShadows = true,
		},
		{
		class = "Particle",
		particleSystem = "torch",
		offset = vec(1.1, 0.85, 0),
		},
	},
	placement = "floor",
	editorIcon = 88,
}

------------------
--- Grave Dirt ---
------------------

defineObject{
	name = "el_floor_grave_pile_01",
	baseObject = "base_floor_decoration",
	tags = { "ew_stuff" },
	components = {
		{
			class = "Model",
			model = "assets/models/env/mine_floor_sandpile.fbx",
			material = "swamp_ground_01",
			dissolveStart = 4,
			dissolveEnd = 6,
			staticShadow = true,
		},
				{
			class = "Obstacle",
			blockMonsters = true,
			blockParty = false,
			blockItems = false,
		},
	},
	editorIcon = 56,
	minimalSaveState = true,
}

-------------
--- Items ---
-------------

defineObject{
	name = "el_rust_long_sword_01",
	baseObject = "base_item",
	components = {
		{
			class = "Model",
			model = "assets/models/items/long_sword.fbx",
		},
		{
			class = "Item",
			uiName = "A Rusty Longsword",
			gfxIndex = 84,
			gfxIndexPowerAttack = 430,
			impactSound = "impact_blade",
			weight = 3.2,
			description = "A mighty weapon, this longsword used to be. Now it's old and rusty, but better than nothing at all.",
			traits = { "light_weapon", "sword" },
		},
		{
			class = "MeleeAttack",
			attackPower = 6,
			accuracy = 1,
			cooldown = 4,
			swipe = "horizontal",
			requirements = { "light_weapons", 1 },
		},
	},
	tags = { "ew_stuff" },
}

---------------------------
--- Auto Script Trigger ---
---------------------------

defineObject{
   name = 'el_script_auto_floor_trigger',
   baseObject = 'script_entity',
   tags = { "ew_stuff" },
    components = {
      {
         class = 'FloorTrigger'
      },
      {
         class = "Script",
         source = [[
function execute(trigger)
   -- your code here
end
self.go.floortrigger:addConnector('onActivate',self.go.id,'execute')
         ]]
      }
    }
}

--------------------------
--- Tree Stump Sockets ---
--------------------------


defineObject{
   name = "el_tree_stump_patch_socket",
   baseObject = "swamp_dead_tree",
   tags = { "ew_stuff" },
   components = {

	{
		class = "Model",
		model = "assets/models/env/swamp_dead_tree.fbx",
		staticShadow = true,
	},
	{
		class = "Surface",
		offset = vec(0.1, 1.6, 0.9), --1.7
		size = vec(0.6, 0.6, 0.6),
	},
	{
		class = "Socket",
        offset = vec(0.1, 1.6, 0.9), --1.7
		rotation = vec(0.1, 0.1, 0.15),
	},
	{
		class = "Clickable",
		offset = vec(0.1, 1.7, 0.9), --1.11
		size = vec(0.6, 0.6, 0.6),
		maxDistance = 1,
		frontFacing = true,
      },
  },
}

defineObject{
   name = "el_tree_stump_patch_socket_txt",
   baseObject = "swamp_dead_tree",
   tags = { "ew_stuff" },
   components = {

	{
	class = "Model",
	model = "assets/models/env/swamp_dead_tree.fbx",
	staticShadow = true,
	},

      {
		class = "Clickable",
		offset = vec(0.1, 1.7, 0.9), --1.11
		--offset = vec(1.1, 1.7, 0.9), --0.9
		size = vec(0.5, 0.5, 0.5),
		maxDistance = 1,
		debugDraw = true,
		--frontFacing = true,
		onClick= function(self)
            hudPrint("Nothing in here.")
         end,

      },
   },
}

----------------------------
--- Keys and Key Sockets ---
----------------------------

----------------------------------
--- Open Cemetry Graves area 1 ---
----------------------------------

defineObject{
	name = "el_grvyrd1_key",
	baseObject = "base_item",
	tags = { "ew_stuff" },
	components = {
		{
			class = "Model",
			model = "assets/models/items/key_iron.fbx",
		},
		{
			class = "Item",
			uiName = "Graveyard Door Key",
			gfxIndex = 22,
			weight = 0.2,
			traits = { "key" },
		},
		{
			class = "Particle",
			particleSystem = "glitter_gold",
		},
	},
}

defineObject{
	name = "el_graveyard_gate_key_1",
	components = {
		{
			class = "Model",
			model = "assets/models/env/wall_lock_round.fbx",
			offset = vec(0, 1.375, 0),
			staticShadow = true,
		},
		{
			class = "Clickable",
			offset = vec(0, 1.38, -0.16),
			size = vec(0.1, 0.1, 0.15),
			--debugDraw = true,
		},
		{
			class = "Socket",
			offset = vec(0, 0, 0), --(-0.42, 1.18, 0),--
			rotation = vec(0, 0, -3),
			onAcceptItem = function(self, item)
			if item.go.name ~= "el_grvyrd1_key" then

			hudPrint("You will need the right key for this lock.")
				return false
				else
				playSound("key_lock")
				return true
				end
			end,
		},
	},
	placement = "wall",
	editorIcon = 92,
	tags = { "ew_stuff" },
}


--------------------------------------------------------------------

			--- Main Quest Items Tyrones Grave area 3 ---

--------------------------------------------------------------------

defineObject{
	name = "el_Tyronefingers_gate_key_1",
	baseObject = "base_item",
	tags = { "ew_stuff" },
	components = {
		{
			class = "Model",
			model = "assets/models/items/key_iron.fbx",
		},
		{
			class = "Item",
			uiName = "Tyrone's Key",
			gfxIndex = 22,
			weight = 0.2,
			traits = { "key" },
		},
		{
			class = "Particle",
			particleSystem = "glitter_gold",
		},
	},
}

defineObject{
	name = "el_quest_item_gate_key_3",
	components = {
		{
			class = "Model",
			model = "assets/models/env/wall_lock_round.fbx",
			offset = vec(0, 1.375, 0),
			staticShadow = true,
		},
		{
			class = "Clickable",
			offset = vec(0, 1.38, -0.16),
			size = vec(0.1, 0.1, 0.15),
			--debugDraw = true,
		},
		{
			class = "Socket",
			offset = vec(0, 0, 0), --(-0.42, 1.18, 0),--
			rotation = vec(0, 0, -3),
			onAcceptItem = function(self, item)
			if item.go.name ~= "el_Tyronefingers_gate_key_1" then

			hudPrint("You will need Tyrone's key to open this door.")
				return false
				else
				playSound("key_lock")
				return true
				end
			end,
		},
	},
	placement = "wall",
	editorIcon = 92,
	tags = { "ew_stuff" },
}


