CHEATS = 
{
	{ title="Party level-up", detail="Raise all party one level.", callback="partyLevelUp" },
	{ title="Party level-up x 5", detail="Raise all party 5 levels.", callback="partyLevelUp5" },
	{ title="Go 6th", detail="Raise party up to 6th level, give 6th lvl items, based on Xanathar's 6th lvl save game of main game.", callback="cheat6" },
	{ title="Armageddon", detail="Kill all monsters in current level.", callback="armageddon" },
	{ title="IDDQD", detail="Become a god.", callback="godLike" },
	{ title="Heal", detail="Heal everyone", callback="heal" },
	{ title="Haste", detail="Go toorum speed", callback="hasteMe" },
	{ title="Back to cheatroom", detail="Go back to the cheatroom", callback="cheatRoom" },
}

g_CurrentCheats = nil;


function _findCheats()
	g_CurrentCheats = { }

	for l = 1, Dungeon.getMaxLevels() do
		for e in Dungeon.getMap(l):allEntities() do
			if (e.script and e.script.CHEATS) then
				for _, c in ipairs(e.script.CHEATS) do 
					g_CurrentCheats[#g_CurrentCheats+1] = {
						title = c.title,
						detail = c.detail, 
						callback = c.callback,
						scriptid = e.id,
					}
				end
			end
		end
	end
	
	return g_CurrentCheats;
end

function hasteMe()
	party.party:setMovementSpeed(2);
end

function cheatRoom()
	party:setPosition(or_cheat_altar.x, or_cheat_altar.y+1, or_cheat_altar.facing, or_cheat_altar.elevation, or_cheat_altar.level);
end



function godLike()
	for i = 1, 4 do 
		local c = party.party:getChampion(i);
		c:upgradeBaseStat("strength", 999);
		c:upgradeBaseStat("dexterity", 999);
		c:upgradeBaseStat("willpower", 999);
		c:upgradeBaseStat("vitality", 999);
		c:trainSkill("alchemy", 5);
		c:trainSkill("athletics", 5);
		c:trainSkill("concentration", 5);
		c:trainSkill("light_weapons", 5);
		c:trainSkill("heavy_weapons", 5);
		c:trainSkill("missile_weapons", 5);
		c:trainSkill("throwing", 5);
		c:trainSkill("firearms", 5);
		c:trainSkill("accuracy", 5);
		c:trainSkill("critical", 5);
		c:trainSkill("armors", 5);
		c:trainSkill("dodge", 5);
		c:trainSkill("fire_magic", 5);
		c:trainSkill("air_magic", 5);
		c:trainSkill("water_magic", 5);
		c:trainSkill("earth_magic", 5);
	end
	party.party:heal()
	
end

function heal()
	party.party:heal()
end


function armageddon()
	for e in party.map:allEntities() do
		if (e.monster) then
			e.monster:die();
		end
	end
end

function partyLevelUp()
	for i = 1, 4 do party.party:getChampion(i):levelUp(); end
end

function partyLevelUp5()
	for i = 1, 5 do partyLevelUp(); end
end

function _spawnStack(name, qty)
	local item = spawn(name).item;
	item:setStackSize(qty)
	return item;
end


function cheat6()
	for i = 1, 4 do    
		while party.party:getChampion(i):getLevel() < 6 do
			party.party:getChampion(i):levelUp();
		end
	end
	
	--[[
ItemSlot.Weapon = 1	
ItemSlot.OffHand = 2	
ItemSlot.Head = 3	
ItemSlot.Chest = 4	
ItemSlot.Legs = 5	
ItemSlot.Feet = 6	
ItemSlot.Cloak = 7	
ItemSlot.Necklace = 8	
ItemSlot.Gloves = 9	
ItemSlot.Bracers = 10	
ItemSlot.Weapon2 = 11	
ItemSlot.OffHand2 = 12	
ItemSlot.BackpackFirst = 13	
ItemSlot.BackpackLast = 32	
ItemSlot.MaxSlots = 32	
	--]]
	
	local c;
	
	c = party.party:getChampion(1);
	c:insertItem(ItemSlot.Head, spawn("bear_skull_helm").item);
	c:insertItem(ItemSlot.Chest, spawn("hide_vest").item);
	c:insertItem(ItemSlot.Legs, spawn("leather_pants").item);
	c:insertItem(ItemSlot.Feet, spawn("leather_boots").item);
	c:insertItem(ItemSlot.Cloak, spawn("tattered_cloak").item);
	--c:insertItem(ItemSlot.Necklace, spawn(""));
	c:insertItem(ItemSlot.Gloves, spawn("reed_gauntlets").item);
	c:insertItem(ItemSlot.Weapon, spawn("long_sword").item);
	c:insertItem(ItemSlot.OffHand, spawn("heavy_shield").item);
	c:insertItem(ItemSlot.BackpackFirst+0, _spawnStack("crystal_shard_healing", 2));
	c:insertItem(ItemSlot.BackpackFirst+1, _spawnStack("potion_healing", 5));

	c = party.party:getChampion(2);
	c:insertItem(ItemSlot.Head, spawn("peasant_cap").item);
	c:insertItem(ItemSlot.Chest, spawn("embalmers_robe").item);
	c:insertItem(ItemSlot.Legs, spawn("rogue_pants").item);
	c:insertItem(ItemSlot.Feet, spawn("leather_boots").item);
	c:insertItem(ItemSlot.Cloak, spawn("tattered_cloak").item);
	c:insertItem(ItemSlot.Necklace, spawn("frostbite_necklace").item);
	c:insertItem(ItemSlot.Gloves, spawn("leather_gloves").item);
	c:insertItem(ItemSlot.Weapon, spawn("warhammer").item);
	c:insertItem(ItemSlot.OffHand, spawn("pearl_shield").item);
	c:insertItem(ItemSlot.BackpackFirst+1, _spawnStack("potion_healing", 5));
	c:insertItem(ItemSlot.BackpackFirst+5, spawn("skull").item);
	c:insertItem(ItemSlot.BackpackFirst+6, spawn("skull").item);

	c = party.party:getChampion(3);
--	c:insertItem(ItemSlot.Head, spawn("peasant_cap").item);
--	c:insertItem(ItemSlot.Chest, spawn("embalmers_robe").item);
--	c:insertItem(ItemSlot.Legs, spawn("rogue_pants").item);
	c:insertItem(ItemSlot.Feet, spawn("shoes").item);
	-- c:insertItem(ItemSlot.Cloak, spawn("tattered_cloak").item);
	-- c:insertItem(ItemSlot.Necklace, spawn("frostbite_necklace").item);
	-- c:insertItem(ItemSlot.Gloves, spawn("leather_gloves").item);
	c:insertItem(ItemSlot.Weapon, spawn("flintlock").item);
	c:insertItem(ItemSlot.OffHand, _spawnStack("pellet_box", 50));
	c:insertItem(ItemSlot.BackpackFirst+1, _spawnStack("potion_healing", 20));

	c = party.party:getChampion(4);
--	c:insertItem(ItemSlot.Head, spawn("peasant_cap").item);
--	c:insertItem(ItemSlot.Chest, spawn("embalmers_robe").item);
--	c:insertItem(ItemSlot.Legs, spawn("rogue_pants").item);
	c:insertItem(ItemSlot.Feet, spawn("shoes").item);
	-- c:insertItem(ItemSlot.Cloak, spawn("tattered_cloak").item);
	-- c:insertItem(ItemSlot.Necklace, spawn("frostbite_necklace").item);
	-- c:insertItem(ItemSlot.Gloves, spawn("leather_gloves").item);
	c:insertItem(ItemSlot.Weapon, spawn("whitewood_wand").item);
	c:insertItem(ItemSlot.OffHand, spawn("magic_orb").item);
	c:insertItem(ItemSlot.BackpackFirst+1, _spawnStack("potion_healing", 5));
	c:insertItem(ItemSlot.BackpackFirst+1, _spawnStack("potion_energy", 20));
end


----
-- Simple Message Box Example
----

shown = false;

function selectMenuCallback(selectedIndex, selectedText)
	shown = false;

	local t = g_CurrentCheats[selectedIndex];
	
	if (t == nil) then return; end
	
	local e = findEntity(t.scriptid);
	
	if (e == nil) then
		print("CHEATER : No such entity named", t.scriptid);
	else
		local fn = e.script[t.callback];
		if (fn == nil) then
			print("CHEATER : Function", t.callback, "not found in script", t.scriptid);
		else
			fn();
		end
	end
end


function showSelectMenu()
	if (shown) then return; end
	
	shown = true;

	local title = "XANATHAR'S CHEAT MENU";
	local message = "Select an option from below, or rethink your life choices.";

	if not g_CurrentCheats then
		_findCheats();
	end

	
	GTKGui.Basic.showSelectMenu(title, message, g_CurrentCheats, self.go.id .. ".script.selectMenuCallback");
end


function dismissSelectMenu()
	GTKGui.Basic.dismissSelectMenu();
end
















