defineObject{
	name = "xan_brothers",
	baseObject = "base_monster_group",
	components = {
		{
			class = "MonsterGroup",
			monsterType = { "xan_garth_ghost", "xan_otis_ghost" },
			count = 2,
		}
	},
}


defineObject{
	name = "xan_garth_ghost",
	baseObject = "base_monster",
	components = {
		{
			class = "Model",
			model = "assets/models/monsters/ice_guardian.fbx",
			storeSourceData = true,
		},
		{
			class = "Animation",
			animations = {
				idle = "assets/animations/monsters/ice_guardian/ice_guardian_idle.fbx",
				moveForward = "assets/animations/monsters/ice_guardian/ice_guardian_walk.fbx",
				strafeLeft = "assets/animations/monsters/ice_guardian/ice_guardian_strafe_left.fbx",
				strafeRight = "assets/animations/monsters/ice_guardian/ice_guardian_strafe_right.fbx",
				turnLeft = "assets/animations/monsters/ice_guardian/ice_guardian_turn_left.fbx",
				turnRight = "assets/animations/monsters/ice_guardian/ice_guardian_turn_right.fbx",
				attack = "assets/animations/monsters/ice_guardian/ice_guardian_attack_close.fbx",
				rangedAttack = "assets/animations/monsters/ice_guardian/ice_guardian_attack_far.fbx",
				getHitFrontLeft = "assets/animations/monsters/ice_guardian/ice_guardian_get_hit_front_left.fbx",
				getHitFrontRight = "assets/animations/monsters/ice_guardian/ice_guardian_get_hit_front_right.fbx",
				getHitBack = "assets/animations/monsters/ice_guardian/ice_guardian_get_hit_back.fbx",
				getHitLeft = "assets/animations/monsters/ice_guardian/ice_guardian_get_hit_left.fbx",
				getHitRight = "assets/animations/monsters/ice_guardian/ice_guardian_get_hit_right.fbx",
				fall = "assets/animations/monsters/ice_guardian/ice_guardian_get_hit_front_left.fbx",
			},
			currentLevelOnly = true,
		},
		{
			class = "IceGuardianBrain",
			name = "brain",
			sight = 0,
			seeInvisible = false,
			morale = 100,
			onInit = function(self) self:disable() end,
		},		
		{
			class = "Monster",
			meshName = "ice_guardian_mesh",
			hitSound = "ice_guardian_hit",
			dieSound = "ice_guardian_die",
			deathEffect = "death_icy",
			hitEffect = "hit_ice",
			capsuleHeight = 0.6,
			capsuleRadius = 0.3,
			collisionRadius = 0.8,
			health = 400,
			protection = 10,
			evasion = 10,
			flying = true,
			exp = 0,
			immunities = { "sleep", "blinded" },
			resistances = {
				fire = "weak",
				cold = "absorb",
			},
			traits = { "elemental" },
			onDie = function() return xan_ending.script.garthGhostCanDie() end,
			onDamage = function() return false end,
			
		},
		{
			class = "MonsterMove",
			name = "move",
			sound = "ice_guardian_walk",
			cooldown = 3,
			animationSpeed = 1.3,
		},
		{
			class = "MonsterTurn",
			name = "turn",
			sound = "ice_guardian_walk",
			animationSpeed = 1.5,
		},
		{
			class = "MonsterChangeAltitude",
			name = "changeAltitude",
			sound = "ice_guardian_walk",
		},
		{
			class = "Light",
			parentNode = "light1",
			color = vec(0.5, 0.8, 1.7),
			offset = vec(0, 0.5, 0.25),
			brightness = 5,
			range = 4,
			fillLight = true,
			--debugDraw = true,
		},		
		{
			class = "Particle",
			particleSystem = "ice_guardian",
			parentNode = "light1",
			rotation = vec(0, 0, 90),
		},
	},
}



defineObject{
	name = "xan_otis_ghost",
	baseObject = "base_monster",
	components = {
		{
			class = "Model",
			model = "assets/models/monsters/uggardian.fbx",
			storeSourceData = true,
		},
		{
			class = "Animation",
			animations = {
				idle = "assets/animations/monsters/uggardian/uggardian_idle.fbx",
				moveForward = "assets/animations/monsters/uggardian/uggardian_walk.fbx",
				strafeLeft = "assets/animations/monsters/uggardian/uggardian_strafe_left.fbx",
				strafeRight = "assets/animations/monsters/uggardian/uggardian_strafe_right.fbx",
				turnLeft = "assets/animations/monsters/uggardian/uggardian_turn_left.fbx",
				turnRight = "assets/animations/monsters/uggardian/uggardian_turn_right.fbx",
				attack = "assets/animations/monsters/uggardian/uggardian_attack.fbx",
				getHitFrontLeft = "assets/animations/monsters/uggardian/uggardian_get_hit_front_left.fbx",
				getHitFrontRight = "assets/animations/monsters/uggardian/uggardian_get_hit_front_right.fbx",
				getHitBack = "assets/animations/monsters/uggardian/uggardian_get_hit_back.fbx",
				getHitLeft = "assets/animations/monsters/uggardian/uggardian_get_hit_left.fbx",
				getHitRight = "assets/animations/monsters/uggardian/uggardian_get_hit_right.fbx",
				fall = "assets/animations/monsters/uggardian/uggardian_get_hit.fbx",
			},
			currentLevelOnly = true,
		},
		{
			class = "Monster",     
			meshName = "uggardian_mesh",
			hitSound = "uggardian_hit",
			dieSound = "uggardian_die",
			hitEffect = "hit_flame",
			capsuleHeight = 0.6,
			capsuleRadius = 0.3,
			collisionRadius = 0.8,
			health = 235,
			protection = 5,
			immunities = { "sleep", "blinded" },
			resistances = { ["fire"] = "absorb", ["cold"] = "weak" },
			evasion = 10,
			flying = true,
			exp = 0,
			traits = { "elemental" },
			onDie = function() return xan_ending.script.otisGhostCanDie() end,
			onDamage = function() return false end,
			
		},
		{
			class = "UggardianBrain",
			name = "brain",
			sight = 5,
			morale = 100,
			seeInvisible = true,
			onInit = function(self) self:disable() end,
		},
		{
			class = "MonsterMove",
			name = "move",
			sound = "uggardian_walk",
			cooldown = 3,
			animationSpeed = 1.3,
		},
		{
			class = "MonsterTurn",
			name = "turn",
			sound = "uggardian_walk",
			animationSpeed = 1.5,
		},
		{
			class = "MonsterAttack",
			name = "rangedAttack",
			attackType = "projectile",
			attackPower = 30,
			cooldown = 6,
			animation = "attack",
			animationSpeed = 1.5,
			sound = "uggardian_attack",
			shootProjectile = "fireball_medium",
		},
		{
			class = "UggardianFlames",
			particleSystem = "uggardian_flames",
			emitFromMaterial = "uggardian_fire",
		},
		{
			class = "Light",
			parentNode = "light1",
			color = vec(1, 0.5, 0.25),
			brightness = 15,
			range = 3.5,
			fillLight = true,
		},
	},
}




