-- ==========================================================================
-- DIGGABLE PIT SETUP
-- ==========================================================================

defineObject{
	name = "xan_dungeon_secret_door_centered",
	baseObject = "base_secret_door",
	components = {
		{
			class = "Model",
			model = "assets/models/env/dungeon_secret_door.fbx",
			offset = vec(0, 0, 1.5),
			staticShadow = true,
		},
	},
}

defineObject{
    name = "xan_offset_floor_dirt",
	baseObject = "base_floor_decoration",
	components = {
		{
			class = "Model",
			model = "assets/models/env/floor_dirt.fbx",
			offset = vec(0, 0, 1.0),
		}
	},
	minimalSaveState = true,
}



defineObject{
	name = "xan_swamp_floor_ph",
	baseObject = "base_floor",
	components = {
		{
			class = "Model",
			model = "mod_assets/rooms/xan/assets/xan_swamp_floor.fbx",
			staticShadow = true,
		},
		{
			class = "Model",
			name = "lowerOffsetFloor",
			model = "mod_assets/rooms/xan/assets/xan_swamp_floor.fbx",
			offset = vec(0, -3, -3),
			staticShadow = true,
		},
	},
}

defineTile{
	name = "xan_diggable_void",
	editorIcon = 192,
	color = {0,0,0,255},
	builder = "dungeon",
	diggable=true,
}

defineObject{
	name = "xan_fake_pit",
	baseObject = "base_floor",
	components = {
		{
			class = "Model",
			model = "assets/models/env/mine_pit.fbx",
			
			materialOverrides = {
				mine_floor_01 = "swamp_ground_01",
			},
			
			dissolveStart = 4,
			dissolveEnd = 6,
			staticShadow = true,
		},
	},
}

defineObject{
	name = "xan_fake_ladder",
	baseObject = "base_floor",
	components = {
		{
			class = "Model",
			model = "assets/models/env/ladder_metal.fbx",
			offset = vec(0,-3,-0.7),
		},
	},
	editorIcon = 248,
	automapIcon = 140,
}


-- ==========================================================================
-- MINEFIELD SHARDS
-- ==========================================================================

defineObject{
	name = "xan_1shard",
	baseObject = "base_floor_decoration",
	components = {
		{
			class = "Model",
			model = "mod_assets/rooms/xan/assets/xan_shard.fbx",
			staticShadow = true,
		},
	},
}

defineObject{
	name = "xan_2shard",
	baseObject = "base_floor_decoration",
	components = {
		{
			class = "Model",
			model = "mod_assets/rooms/xan/assets/xan_shard.fbx",
			staticShadow = true,
			offset = vec(0,0, 0.25),
		},
	},
}

defineObject{
	name = "xan_3shard",
	baseObject = "base_floor_decoration",
	components = {
		{
			class = "Model",
			model = "mod_assets/rooms/xan/assets/xan_shard.fbx",
			staticShadow = true,
		},
	},
}

-- ==========================================================================
-- MINOR REDEFS OF STANDARD ASSETS
-- ==========================================================================


defineObject{
	name = "xan_door_spear",
	baseObject = "base_door",
	components = {
		{
			class = "Model",
			model = "assets/models/env/mine_door_spear.fbx",
			offset = vec(0, 0, 0.15),
		},
		{
			class = "Door",
			openVelocity = 2,
			closeVelocity = -2,
			openingDirection = "down",
			maxHeight = 2,
			sparse = true,
			killPillars = false,
			openSound = "spear_door",
			closeSound = "spear_door",
		},
	},
}

defineObject{
	name = "xan_dungeon_bridge",
	baseObject = "base_floor_decoration",
	components = {
		{
			class = "Model",
			model = "assets/models/env/dungeon_floor_dirt_01.fbx",
			staticShadow = true,
		},
		{
			class = "Platform",
		},
	},
	editorIcon = 184,
	automapIcon = 136,
}


-- ==========================================================================
-- RUNE WALLS
-- ==========================================================================

defineMaterial{
	name = "xan_icewall",
	diffuseMap = "mod_assets/rooms/xan/assets/ice.tga",
	specularMap = "assets/textures/env/dungeon_wall_01_spec.tga",
	normalMap = "assets/textures/env/dungeon_wall_01_normal.tga",
	doubleSided = false,
	lighting = true,
	alphaTest = false,
	blendMode = "Opaque",
	textureAddressMode = "Wrap",
	glossiness = 25,
	depthBias = 0,
}

defineMaterial{
	name = "xan_firewall",
	diffuseMap = "mod_assets/rooms/xan/assets/fire.tga",
	specularMap = "assets/textures/env/dungeon_wall_01_spec.tga",
	normalMap = "assets/textures/env/dungeon_wall_01_normal.tga",
	doubleSided = false,
	lighting = true,
	alphaTest = false,
	blendMode = "Opaque",
	textureAddressMode = "Wrap",
	glossiness = 25,
	depthBias = 0,
}


defineObject{
	name = "xan_firewall",
	baseObject = "base_wall",
	components = {
		{
			class = "Model",
			model = "assets/models/env/dungeon_wall_01.fbx",
			staticShadow = true,
			materialOverrides = {
				dungeon_wall_01 = "xan_firewall",
			}
		},
		{
			class = "Occluder",
			model = "assets/models/env/dungeon_wall_01_occluder.fbx",
		},
		{
			class = "WallText",
		},
		{
			class = "Clickable",
			offset = vec(0, 1.5, 0),
			size = vec(2, 2, 0.2),
			frontFacing = true,
			--debugDraw = true,
		},		
	},
	editorIcon = 92,
	replacesWall = true,
	minimalSaveState = true,
}

defineObject{
	name = "xan_icewall",
	baseObject = "base_wall",
	components = {
		{
			class = "Model",
			model = "assets/models/env/dungeon_wall_01.fbx",
			staticShadow = true,
			materialOverrides = {
				dungeon_wall_01 = "xan_icewall",
			}
		},
		{
			class = "Occluder",
			model = "assets/models/env/dungeon_wall_01_occluder.fbx",
		},
		{
			class = "WallText",
		},
		{
			class = "Clickable",
			offset = vec(0, 1.5, 0),
			size = vec(2, 2, 0.2),
			frontFacing = true,
			--debugDraw = true,
		},		
	},
	editorIcon = 92,
	replacesWall = true,
	minimalSaveState = true,
}

-- ==========================================================================
-- CORPSES
-- ==========================================================================


defineMaterial{
	name = "xan_floor_corpse_bones_only",
	diffuseMap = "mod_assets/rooms/xan/assets/corpse_bones_dif.tga",
	specularMap = "mod_assets/rooms/xan/assets/corpse_bones_spec.tga",
	normalMap = "assets/textures/props/floor_corpse_normal.tga",
	doubleSided = false,
	lighting = true,
	alphaTest = true,
	blendMode = "Opaque",
	textureAddressMode = "Wrap",
	glossiness = 20,
	depthBias = 0,
}


defineObject{
    name = "xan_floor_corpse_bones_only",
	baseObject = "base_floor_decoration",
	components = {
		{
			class = "Model",
			model = "assets/models/env/floor_corpse.fbx",
			material = "xan_floor_corpse_bones_only"
		}
	},
	minimalSaveState = true,
}

defineObject{
	name = "dungeon_ice_pit",
	baseObject = "base_floor_decoration",
	components = {
		{
			class = "Model",
			model = "assets/models/env/dungeon_fire_pit.fbx",
			staticShadow = true,
			
			materialOverrides = {
				magma = "xan_mtl_icy_golem",
				red_beam = "blue_beam",
			},
		},
		{
			class = "Light",
			offset = vec(0, -1, 0),
			range = 6,
			color = vec(0.3, 0.7, 1.3),
			brightness = 10,
			castShadow = true,
			staticShadows = true,
			onUpdate = function(self)
				local noise = math.noise(Time.currentTime()*3 + 123) * 0.5 + 0.9
				self:setBrightness(noise * 15)
			end,
		},
		{
			class = "Occluder",
			model = "assets/models/env/dungeon_pit_occluder.fbx",
		}
	},
	editorIcon = 136,
	replacesFloor = true,
}


defineMaterial{
	name = "xan_dungeon_button1",
	diffuseMap = "mod_assets/rooms/xan/assets/button_1.tga",
	normalMap = "mod_assets/rooms/xan/assets/button_n.tga",
	specularMap = "mod_assets/rooms/xan/assets/button_1.tga",
	doubleSided = false,
	lighting = true,
	alphaTest = false,
	blendMode = "Opaque",
	textureAddressMode = "Wrap",
	glossiness = 80,
	depthBias = 0,
}

defineMaterial{
	name = "xan_dungeon_button2",
	diffuseMap = "mod_assets/rooms/xan/assets/button_2.tga",
	normalMap = "mod_assets/rooms/xan/assets/button_n.tga",
	specularMap = "mod_assets/rooms/xan/assets/button_2.tga",
	doubleSided = false,
	lighting = true,
	alphaTest = false,
	blendMode = "Opaque",
	textureAddressMode = "Wrap",
	glossiness = 80,
	depthBias = 0,
}

defineMaterial{
	name = "xan_dungeon_button3",
	diffuseMap = "mod_assets/rooms/xan/assets/button_3.tga",
	normalMap = "mod_assets/rooms/xan/assets/button_n.tga",
	specularMap = "mod_assets/rooms/xan/assets/button_3.tga",
	doubleSided = false,
	lighting = true,
	alphaTest = false,
	blendMode = "Opaque",
	textureAddressMode = "Wrap",
	glossiness = 80,
	depthBias = 0,
}

defineMaterial{
	name = "xan_dungeon_button4",
	diffuseMap = "mod_assets/rooms/xan/assets/button_4.tga",
	normalMap = "mod_assets/rooms/xan/assets/button_n.tga",
	specularMap = "mod_assets/rooms/xan/assets/button_4.tga",
	doubleSided = false,
	lighting = true,
	alphaTest = false,
	blendMode = "Opaque",
	textureAddressMode = "Wrap",
	glossiness = 80,
	depthBias = 0,
}

defineMaterial{
	name = "xan_dungeon_button5",
	diffuseMap = "mod_assets/rooms/xan/assets/button_5.tga",
	normalMap = "mod_assets/rooms/xan/assets/button_n.tga",
	specularMap = "mod_assets/rooms/xan/assets/button_5.tga",
	doubleSided = false,
	lighting = true,
	alphaTest = false,
	blendMode = "Opaque",
	textureAddressMode = "Wrap",
	glossiness = 80,
	depthBias = 0,
}

defineObject{
	name = "xan_wall_button_1",
	baseObject = "wall_button",
	components = {
		{
			class = "Model",
			model = "assets/models/env/wall_button.fbx",
			material = "xan_dungeon_button1",
		},
	},
}

defineObject{
	name = "xan_wall_button_2",
	baseObject = "wall_button",
	components = {
		{
			class = "Model",
			model = "assets/models/env/wall_button.fbx",
			material = "xan_dungeon_button2",
		},
	},
}

defineObject{
	name = "xan_wall_button_3",
	baseObject = "wall_button",
	components = {
		{
			class = "Model",
			model = "assets/models/env/wall_button.fbx",
			material = "xan_dungeon_button3",
		},
	},
}

defineObject{
	name = "xan_wall_button_4",
	baseObject = "wall_button",
	components = {
		{
			class = "Model",
			model = "assets/models/env/wall_button.fbx",
			material = "xan_dungeon_button4",
		},
	},
}

defineObject{
	name = "xan_wall_button_5",
	baseObject = "wall_button",
	components = {
		{
			class = "Model",
			model = "assets/models/env/wall_button.fbx",
			material = "xan_dungeon_button5",
		},
	},
}













