
defineSpell{
	name = "xan_feeling_lucky",
	uiName = "Wild Surge",
	gesture = 0,
	manaCost = 5,
	skill = "concentration",
	requirements = { "concentration", 2 },
	icon = 59,
	spellIcon = 0,
	description = "",
	hidden = true,
	onCast = function(champion, x, y, direction, elevation, skillLevel)
		xan_wildmage.script.wildSurgeRandom(champion, 100);
	end,
}


defineSpell{
	name = "xan_entrap_soul",
	uiName = "Entrap Soul",
	gesture = 0,
	manaCost = 25,
	skill = "concentration",
	requirements = { "concentration", 4 },
	icon = 59,
	spellIcon = 0,
	description = "",
	hidden = true,
	onCast = function(champion, x, y, direction, elevation, skillLevel)
		xan_wildmage.script.castEntrapSoul(champion, x, y, direction, elevation, skillLevel);
	end,
}


defineObject{
	name = "xan_soulTrapper",
	baseObject = "base_spell",
	components = {
		{
			class = "Particle",
			particleSystem = "blob",
		},
		{
			class = "Light",
			color = vec(1,1,1),
			brightness = 15,
			range = 7,
		},
		{
			class = "Sound",
			sound = "blob",
		},
		{
			class = "Sound",
			name = "launchSound",
			sound = "blob_launch",
		},
		{
			class = "Projectile",
			spawnOffsetY = 1.15,
			velocity = 7.5,
			radius = 0.1,
			onProjectileHit = function(self, what, entity)
				local ent
				if entity and (entity.monster) then
					ent = self.go:spawn("blob_hit_receptor")
					
					xan_wildmage.script.registerMonsterForSoul(entity);
				else
					ent = self.go:spawn("blob_blast")
				end
				ent:setWorldPosition(self.go:getWorldPosition())
			end,
		},
	},
}

defineTrait{
	name = "xan_wild_mage",
	uiName = "Wild Magic",
	priority = 100,
	icon = 6,
	iconAtlas = "mod_assets/rooms/xan/assets/atlas.tga",
	description = "As a gift from the mighty Garth Raynal, chaos will reign your powers and every spell you cast has a chance of causing a wild surge of chaos energy. To counter balance, you have access to more energy than before.",
	gameEffect = "Grants wild magic 'powers'.",
	charGen = false,
}

defineTrait{
	name = "xan_fire_a",
	uiName = "Gift of Otis : Power",
	priority = 100,
	icon = 13,
	iconAtlas = "mod_assets/rooms/xan/assets/atlas.tga",
	description = "A gift from the mighty Otis Medusa, you have increased magic skills.",
	gameEffect = "Increased fire magic skills.",
	charGen = false,
}

defineTrait{
	name = "xan_fire_d",
	uiName = "Gift of Otis : Resist",
	priority = 100,
	icon = 14,
	iconAtlas = "mod_assets/rooms/xan/assets/atlas.tga",
	description = "A gift from the mighty Otis Medusa you have increased magic resistances.",
	gameEffect = "Increased fire resistance.",
	charGen = false,
}

defineTrait{
	name = "xan_ice_a",
	uiName = "Gift of Garth : Power",
	priority = 100,
	icon = 15,
	iconAtlas = "mod_assets/rooms/xan/assets/atlas.tga",
	description = "A gift from the mighty Garth Raynal, you have increased magic skills.",
	gameEffect = "Increased water magic skills.",
	charGen = false,
}

defineTrait{
	name = "xan_ice_d",
	uiName = "Gift of Garth : Resist",
	priority = 100,
	icon = 16,
	iconAtlas = "mod_assets/rooms/xan/assets/atlas.tga",
	description = "A gift from the mighty Garth Raynal you have increased magic resistances.",
	gameEffect = "Increased cold resistance.",
	charGen = false,
}
















 
 