defineObject{
	name = "xan_orb_o_cheats",
	baseObject = "base_item",
	components = {
		{
			class = "Model",
			model = "assets/models/items/apprentice_orb.fbx",
		},
		{
			class = "Item",
			uiName = "Dirty Deeds Done Dirt Cheats",
			gfxAtlas = "mod_assets/rooms/xan/assets/atlas.tga",
			description = "This orb allows dirty cheaters to work their way in the dungeon at the sound of australian hard rock music.",
			gfxIndex = 18,
			weight = 1.0,
			gameEffect = "CHEAT! OK ?",
			traits = { "tome" },
		},
		{
			class = "UsableItem",
			sound = "level_up",
			onUseItem = function(self, champion)
				xan_cheat.script.showSelectMenu();
				return false;
			end,
		},
	},
}

defineObject{
	name = "xan_skiff_round_key",
	baseObject = "base_item",
	components = {
		{
			class = "Model",
			model = "assets/models/items/key_round.fbx",
		},
		{
			class = "Item",
			uiName = "Key to Skiff burial ground",
			gfxIndex = 62,
			weight = 0.2,
			traits = { "key" },
		},
		{
			class = "Particle",
			particleSystem = "glitter_silver",
		},
		
	},
}

defineObject{
	name = "xan_exit_key",
	baseObject = "ornate_key",
	components = {
		{
			class = "Item",
			uiName = "Key of the Medusa/Raynal tomb",
			gfxIndex = 63,
			weight = 0.2,
			traits = { "key" },
		},
	},
}

defineObject{
	name = "xan_chamber_key",
	baseObject = "skull_key",
	components = {
		{
			class = "Item",
			uiName = "Key to the inner tombs",
			gfxIndex = 407,
			weight = 0.2,
			traits = { "key" },
		},
	},
}



defineObject{
	name = "xan_fire_jammer",
	baseObject = "base_item",
	components = {
		{
			class = "Model",
			model = "assets/models/items/essence_fire.fbx",
		},
		{
			class = "Item",
			uiName = "Fiery golem heart",
			gfxIndex = 346,
			impactSound = "impact_blunt",
			weight = 2,
		},
		{
			class = "Particle",
			particleSystem = "essence_fire",
		},
		{
			class = "Light",
			offset = vec(0, 0.5, 0),
			range = 1.5,
			color = vec(1, 0.5, 0.25),
			brightness = 30,
			castShadow = false,
		},
	},
}

defineObject{
	name = "xan_ice_jammer",
	baseObject = "base_item",
	components = {
		{
			class = "Model",
			model = "assets/models/items/essence_water.fbx",
		},
		{
			class = "Item",
			uiName = "Icy golem heart",
			gfxIndex = 349,
			impactSound = "impact_blunt",
			weight = 2,
		},
		{
			class = "Particle",
			particleSystem = "essence_water",
		},
		{
			class = "Light",
			offset = vec(0, 0.5, 0),
			range = 1.5,
			color = vec(0.25, 0.5, 1.25),
			brightness = 30,
			castShadow = false,
		},
	},
}


defineMaterial{
	name = "xan_chaos_soulgem",
	diffuseMap = "mod_assets/rooms/xan/assets/soulgem_d.tga",
	specularMap = "mod_assets/rooms/xan/assets/soulgem_s.tga",
	doubleSided = false,
	lighting = true,
	alphaTest = false,
	blendMode = "Opaque",
	textureAddressMode = "Wrap",
	glossiness = 120,
	depthBias = 0,
	onUpdate = function(self, time)
		self:setTexcoordScaleOffset(0.5, 1, time*0.05, 0)
	end,	
}

defineMaterial{
	name = "xan_soulgem",
	diffuseMap = "mod_assets/rooms/xan/assets/soulgem2_d.tga",
	specularMap = "mod_assets/rooms/xan/assets/soulgem2_s.tga",
	doubleSided = false,
	lighting = true,
	alphaTest = false,
	blendMode = "Opaque",
	textureAddressMode = "Wrap",
	glossiness = 120,
	depthBias = 0,
	onUpdate = function(self, time)
		self:setTexcoordScaleOffset(0.5, 1, time*0.05, 0)
	end,	
}

defineObject{
	name = "xan_chaos_soulgem",
	baseObject = "base_item",
	components = {
		{
			class = "Model",
			model = "assets/models/items/zhandul_orb.fbx",
			material = "xan_chaos_soulgem",
		},
		{
			class = "Item",
			uiName = "Surgeoff's Soul-Gem",
			description = [[
This soul gem contains the very soul of Boris Surgeoff. 
It's said that after his death his daughter evoked his spirit to trap the raw power his soul contained. 
The result is this gem of incomparable power. 
The dark ritual condemned his soul to eternal undeath, and drove the daughter to insanity.

The soulgem vibrates slightly to the touch. When close to a container of some kind, the container gets repulsed as if they were magnets of the same polarity.
]],
			gfxIndex = 31,
			gfxIndexPowerAttack = 26,
			gfxAtlas = "mod_assets/rooms/xan/assets/atlas.tga",
			impactSound = "impact_blunt",
			weight = 2.5,
			gameEffect = "Bearer gains wild magic \"powers\".",
			fitContainer = false, -- needed so player can't cheat :)
			secondaryAction = "xan_feeling_lucky",
		},
		{
			class = "RunePanel",
			requirements = { "concentration", 2 },
		},
		{
			class = "EquipmentItem",
			slot = "Weapon",
			willpower = 20,
			energy = 100,
		},
		{
			class = "Light",
			offset = vec(0, 0.5, 0),
			range = 1.5,
			color = vec(2.25, 0, 2.25),
			brightness = 30,
			castShadow = false,
		},		
		{
			class = "CastSpell",
			name = "xan_feeling_lucky",
			uiName = "I'm feeling lucky!",
			spell = "xan_feeling_lucky",
			energyCost = 5,
			cooldown = 0,
			power = 0,
			requirements = { "concentration", 2 },
		},		
	},
}




defineObject{
	name = "xan_soulgem",
	baseObject = "base_item",
	components = {
		{
			class = "Model",
			model = "assets/models/items/zhandul_orb.fbx",
			material = "xan_soulgem",
		},
		{
			class = "Item",
			uiName = "Soul-Gem",
			description = [[
Once the container of the soul of the mighty Boris Surgeoff, now this soul gem has been emptied of its mighty power.
It may still entrap a soul, granting different powers depending on the trapped soul's own power.]],
			gfxIndex = 0,
			gfxIndexPowerAttack = 26,
			gfxAtlas = "mod_assets/rooms/xan/assets/atlas.tga",
			impactSound = "impact_blunt",
			weight = 2.5,
			secondaryAction = "xan_entrap_soul",
			gameEffect = "Entrap soul : Currently empty.",
		},
		{
			class = "EquipmentItem",
			name = "equipmentItem",
			slot = "Weapon",
		},		
		{
			class = "RunePanel",
			requirements = { "concentration", 2 },
		},
		{
			class = "CastSpell",
			name = "xan_entrap_soul",
			uiName = "Entrap soul",
			spell = "xan_entrap_soul",
			energyCost = 25,
			cooldown = 15,
			power = 3,
			requirements = { "concentration", 4 },
		},
	},
}



defineMaterial{
	name = "xan_blinding_boots",
	diffuseMap = "mod_assets/rooms/xan/assets/blinding_boots.tga",
	specularMap = "assets/textures/common/black.tga",
	doubleSided = false,
	lighting = true,
	alphaTest = false,
	blendMode = "Opaque",
	textureAddressMode = "Wrap",
	glossiness = 20,
	depthBias = 0,
}


defineObject{
	name = "xan_blinding_boots",
	baseObject = "base_item",
	components = {
		{
			class = "Model",
			model = "assets/models/items/archmage_loafers.fbx",
			material = "xan_blinding_boots",
		},
		{
			class = "Item",
			uiName = "Boots of Blinding Speed",
			
description = "These boots, originally made as a joke, were once sought after by all kind of bards for what they perceived as a double advantage: blindness to have better 'ears', like many musicians of the present and past and unbelievable speed to play faster tempos. It turned out that being blind doesn't automatically grant you a better 'ear' and that having faster legs doesn't help music related skills unless you play drums.",
			
			gameEffect = "Increased movement speed, near blindness.",

			gfxIndex = 17,
			gfxAtlas = "mod_assets/rooms/xan/assets/atlas.tga",
			weight = 2.6,
			traits = { "boots" },
			
			onEquipItem = function(self, champion, slot) 
				xan_hooks.script.blindingBootsEquip(self, champion, slot, true);
			end,

			onUnequipItem = function(self, champion, slot) 
				xan_hooks.script.blindingBootsEquip(self, champion, slot, false);
			end,
		},
		{
			class = "EquipmentItem",
			protection = 2,
			evasion = -25,
			accuracy = -25,
			dexterity = -5,
		},
	},
}

defineMaterial{
	name = "xan_worker_helmet",
	diffuseMap = "mod_assets/rooms/xan/assets/yellow.tga",
	specularMap = "mod_assets/rooms/xan/assets/yellow.tga",
	doubleSided = false,
	lighting = true,
	alphaTest = false,
	blendMode = "Opaque",
	textureAddressMode = "Wrap",
	glossiness = 250,
	depthBias = 0,
}


defineObject{
	name = "xan_worker_helmet",
	baseObject = "base_item",
	components = {
		{
			class = "Model",
			model = "assets/models/items/reed_helmet.fbx",
			material = "xan_worker_helmet",
		},
		{   
			class = "Item",
			uiName = "Construction Worker Helmet",
			description = "This helmet is a favorite among construction workers, diggers and the likes. It helps preserving lives and getting through the lunch break.",
			armorSet = "reed",
			gfxIndex = 16,
			gfxAtlas = "mod_assets/rooms/xan/assets/atlas.tga",
			weight = 0.8,
			traits = { "light_armor", "helmet" },
			gameEffect = "Food Consumption Rate + 30%",
		},
		{
			class = "EquipmentItem",
			protection = 8,
			foodRate = 30,
		},
	},
}

defineObject{
	name = "xan_mark_knoffer",
	baseObject = "base_item",
	components = {
		{
			class = "Model",
			model = "assets/models/items/morning_star.fbx",
		},
		{
			class = "Item",
			uiName = "Mark Knoffer",
			description = "Mana for nothin' and hits for free.",
			gfxIndex = 3,
			gfxIndexPowerAttack = 203,
			impactSound = "impact_blunt",
			weight = 5.0,
			traits = { "heavy_weapon", "mace" },
		},
		{
			class = "MeleeAttack",
			attackPower = 16,
			accuracy = 5,
			pierce = 5,
			cooldown = 4.5,
			swipe = "vertical",
			requirements = { "heavy_weapons", 1 },
			powerAttackTemplate = "stun",
		},
		{
			class = "EquipmentItem",
			slot = "Weapon",
			energy = 15,
		},
		
	},
	tags = { "weapon" },
}


