Ending = {
	-- Do not rename items of this "enum".
	not_found = 0,
	maintalk = 1,
	waiting_gem = 2,
	destroy_startUp = 3,
	destroy_turnGolems = 4,
	destroy_golemsHit = 5,
	destroy_destroyGem = 6,
	destroy_destroyGolems = 7,
	destroy_cleanUp = 8,
	gem_destroyed_party = 10,
	gem_destroyed_sylina = 99,
	gem_destroyed_abandoned = 98,
}

endingState = Ending.not_found;

isOtisDead = false;
isGarthDead = false;

garthId = nil;
otisId = nil;

hasGainedWildMageTrait = false;
hasTrappedABrotherSoul = false;


function setTrappedSoulBrother()
	hasTrappedABrotherSoul = true;
end

function cheat()
	mainTalkDone();
	_setEndingState(Ending.gem_destroyed_party);
end


function garthGhostCanDie()
	return isGarthDead;
end

function otisGhostCanDie()
	return isOtisDead;
end

function _killGhost(ghostid)
	local ghost = findEntity(ghostid);
	
	if (ghost ~= nil) then
		ghost.monster:die();
	end
end

function _killOtis()
	isOtisDead = true;
	_killGhost(otisId);
end

function _killGarth()
	isGarthDead = true;
	_killGhost(garthId);
end

-- REWARDS:

function trappedReward() _killOtis(); _killGarth(); end

function rewardPwrOtis1() _rewardPwr(1, "fire_magic", "Fire Magic", "xan_fire_a"); _killOtis(); end
function rewardPwrOtis2() _rewardPwr(2, "fire_magic", "Fire Magic", "xan_fire_a"); _killOtis(); end
function rewardPwrOtis3() _rewardPwr(3, "fire_magic", "Fire Magic", "xan_fire_a"); _killOtis(); end
function rewardPwrOtis4() _rewardPwr(4, "fire_magic", "Fire Magic", "xan_fire_a"); _killOtis(); end

function rewardPwrGarth1() _rewardPwr(1, "water_magic", "Water Magic", "xan_ice_a"); _killGarth(); end
function rewardPwrGarth2() _rewardPwr(2, "water_magic", "Water Magic", "xan_ice_a"); _killGarth(); end
function rewardPwrGarth3() _rewardPwr(3, "water_magic", "Water Magic", "xan_ice_a"); _killGarth(); end
function rewardPwrGarth4() _rewardPwr(4, "water_magic", "Water Magic", "xan_ice_a"); _killGarth(); end

function rewardWild1() _rewardWild(1); _killGarth(); end
function rewardWild2() _rewardWild(2); _killGarth(); end
function rewardWild3() _rewardWild(3); _killGarth(); end
function rewardWild4() _rewardWild(4); _killGarth(); end


function rewardDefOtis() _rewardResist("resist_fire", "xan_fire_d"); _killOtis(); end
function rewardDefGarth() _rewardResist("resist_cold", "xan_ice_d"); _killGarth(); end


function _rewardPwr(idx, mainSkill, mainSkillName, trait)
	local c = party.party:getChampion(idx); 
	
	c:setSkillPoints(c:getSkillPoints() + 1);
	
	if (c:getSkillLevel(mainSkill) < 5) then
		hudPrint (c:getName() .. " gained +1 " .. mainSkillName);
		c:trainSkill(mainSkill, 1);
	elseif (c:getSkillLevel("concentration") < 5) then
		hudPrint (c:getName() .. " gained +1 Concentration");
		c:trainSkill("concentration", 1);
	else
		hudPrint (c:getName() .. " gained +1 skill point");
	end
	
	c:addTrait(trait);
	hudPrint(c:getName() .. " gained a gift trait.");
end



function _rewardWild(idx)
	local c = party.party:getChampion(idx); 
	c:addTrait("xan_wild_mage");
	c:upgradeBaseStat("max_energy", 50);
	hudPrint(c:getName() .. " gained the Wild Magic trait.");
	hasGainedWildMageTrait = true;
end


function _rewardResist(resist, trait)
	for i = 1, 4 do 
		local c = party.party:getChampion(i); 
		local class = c:getClass();
		local amount = 0;
		
		c:addTrait(trait);
		
		if (class == "wizard" or class == "battle_mage") then
			amount = 15;
		elseif (class == "alchemist" or class == "farmer" or class == "rogue") then
			amount = 10;
		else
			amount = 5;
		end

		c:upgradeBaseStat(resist, amount);
	end
	
	hudPrint("The party has been granted a gift trait.");
end






 
-- activate the ending
function activate()
	if (endingState == Ending.not_found) then
		spawn("xan_brothers", xan_brothers_teleporter.level, xan_brothers_teleporter.x,
			xan_brothers_teleporter.y, xan_brothers_teleporter.facing, xan_brothers_teleporter.elevation);
			
		_setEndingState(Ending.maintalk);
	end
end

-- talk done
function mainTalkDone()
	_setEndingState(Ending.waiting_gem);

	xan_brothers_teleporter.controller:activate();
	-- these teleps will move items
	xan_otis_teleporter.controller:activate();
	xan_garth_teleporter.controller:activate();
	
	delayedCall(self.go.id, 0.5, "onTeleportEnd");
	
	local garth = spawn("xan_garth_ghost", xan_final_altar.level, xan_final_altar.x,
		xan_final_altar.y + 1, xan_final_altar.facing, xan_final_altar.elevation);

	local otis = spawn("xan_otis_ghost", xan_final_altar.level, xan_final_altar.x,
		xan_final_altar.y - 1, xan_final_altar.facing, xan_final_altar.elevation);
	
	garthId = garth.id;
	otisId = otis.id;
end
  
function onTeleportEnd()
	xan_brothers_teleporter.controller:deactivate();
	xan_otis_teleporter.controller:deactivate();
	xan_garth_teleporter.controller:deactivate();
end

function _mustBeDone(name, queuedAction, message)
	local dialogue = {
		lockParty = true,
		startPage = startPage,
		pages = {
			{
				id = "first",
				speakerName = "Avatar of " .. name,
				speakerMessage = message,
				responses = {
					{ text = "(Leave)", onSelect = self.go.id .. ".script." .. queuedAction },					
				} 
			},
		}
	}

	GTKGui.Dialogue.startDialogue(dialogue);
end

function getPartyChoiceResponses(methodName, magesOnly)
	local t = { }

	for i = 1, 4 do
		local c = party.party:getChampion(i);
		local add = true;
		
		if (magesOnly) then
			add = (c:getClass() == "wizard") or (c:getClass() == "battle_mage");
		end
		
		if (add and c:getEnabled()) then
			t[#t + 1] = { 
				text = (c:getName() .. " [" .. c:getRace() .. " " .. c:getClass() .. " of " .. c:getLevel() .. " level]"), 
				onSelect = (methodName .. i), 
			}
		end
	end

	t[#t + 1] = { text = "I've changed my mind" }
	
	return t;
end


function _reward(name, message, actionSuffix)
	local powerPrefix = "Wise choice. ";
	local resistPrefix = "Mmm, ok, as you wish. ";
	
	if (actionSuffix == "Otis") then 
		resistPrefix = "Wise choice. ";
		powerPrefix = "Mmm, ok, as you wish. ";
	end


	local dialogue = {
		lockParty = true,
		startPage = startPage,
		pages = {
			{
				id = "first",
				speakerName = "Avatar of " .. name,
				speakerMessage = message,
				responses = {
					{ text = "I want power. More power.", nextPage = "power" },
					{ text = "I want to be more resistant.", nextPage = "resist" },
					{ text = "I liked the wild magic powers. Can I have it back ?", nextPage = "wild" },					
					{ text = "(Leave)" },					
				} 
			},
			{
				id = "power",
				speakerName = "Avatar of " .. name,
				speakerMessage = powerPrefix .. "Tell me who should receive my power. And then I'll be free to leave this world once and for all.",
				responses = getPartyChoiceResponses(self.go.id .. ".script.rewardPwr" .. actionSuffix),
			},
			{
				id = "resist",
				speakerName = "Avatar of " .. name,
				speakerMessage = resistPrefix .. "Take part of my resistance, where I'm going I don't need it anymore. Goodbye.",
				responses = {
					{ text = "Goodbye.", onSelect = self.go.id .. ".script.rewardDef" .. actionSuffix },
				} 
			},
			{
				
			}
		}
	}
	
	if (hasGainedWildMageTrait) then
		dialogue.pages[1].responses[3] = dialogue.pages[1].responses[4];
		dialogue.pages[1].responses[4] = nil;
	end
	
	if (hasTrappedABrotherSoul) then
		dialogue = {
			lockParty = true,
			startPage = startPage,
			pages = {
				{
					id = "first",
					speakerName = "Avatar of " .. name,
					speakerMessage = "You bastard, you betrayed our trust by trapping my brother's soul! Hope you die soon." ,
					responses = {
						{ text = "(Leave)", onSelect = self.go.id .. ".script.trappedReward" },
					} 
				},
			}
		}
	end

	
	if (actionSuffix == "Otis") then 
		dialogue.pages[4] = 
			{
				id = "wild",
				speakerName = "Avatar of " .. name,
				speakerMessage = "I can't give you that gift. Above all, I don't WANT to give you that gift. You don't really know what you're asking for.",
				responses = {
					{ text = "OK.", nextPage = "first" },
				}
			} 
	else
		dialogue.pages[4] = 
			{
				id = "wild",
				speakerName = "Avatar of " .. name,
				speakerMessage = "Are you sure ? Magic, and life, won't ever be the same. Plus wild magic tends to hurt its owner more than their targets. And there is no coming back.",
				responses = {
					{ text = "I'm sure. I want to be a wild mage for my entire life.", nextPage = "wild_ok" },
					{ text = "I want to think about it a little more." },
				}
			}
		dialogue.pages[5] = 
			{
				id = "wild_ok",
				speakerMessage = "There'll be chaos in your soul. (He tends an arm to you, and touches your heart with a cold finger). Tell me who will host this power and I'll be free to leave this world",
				responses = getPartyChoiceResponses(self.go.id .. ".script.rewardWild", true),
			} 
			
		if (#(dialogue.pages[5].responses) == 1) then
			dialogue.pages[5] = 
				{
					id = "wild_ok",
					speakerMessage = "No, nobody in your party has the right magic skills, sorry. Choose something else.",
					responses = {
						{ text = "OK.", nextPage = "first" },
					}
				} 
		end
	end

	GTKGui.Dialogue.startDialogue(dialogue);
end

function turnGarthFront()
	_turnToFront(garthId, "L");
end

function turnOtisFront()
	_turnToFront(otisId, "R");
end

function _turnToFront(id, direction)
	local talker = findEntity(id);
	
	if (talker ~= nil) then
		if (talker.facing ~= xan_final_altar.facing) then
			if (direction == "R") then
				talker.brain:turnRight();
			else 
				talker.brain:turnLeft();
			end
		end
	end
end

function _turnToTalk(id, direction)
	local talker = findEntity(id);
	
	if (talker ~= nil) then
		if (talker.facing == xan_final_altar.facing) then
			if (direction == "R") then
				talker.brain:turnRight();
			else 
				talker.brain:turnLeft();
			end
		end
	end
end

function otisRewardTalk(sender)
	if (endingState < Ending.waiting_gem) then return; end
	if (isOtisDead) then return; end

	if (endingState == Ending.waiting_gem) then
		_turnToTalk(otisId, "L");
		return _mustBeDone("Otis Medusa", "turnOtisFront", "We are dead because of that very soulgem. We and who knows how many others. Go on. Put between the golems.");
	end
	
	if (endingState == Ending.gem_destroyed_party) then
		_turnToTalk(otisId, "L");
		return _reward("Otis Medusa", "You did well. Before I leave this world forever, you deserve a reward. What would you want: to be more powerful or to live a longer life ? Choose wisely.", "Otis");
	end
	
	hudPrint "He looks busy.";
end	

function garthRewardTalk(sender)
	if (endingState < Ending.waiting_gem) then return; end
	if (isGarthDead) then return; end

	if (endingState == Ending.waiting_gem) then
		_turnToTalk(garthId, "R");
		return _mustBeDone("Garth Raynal", "turnGarthFront", "Don't think it's easy for me, I spent my life searching that soulgem.. But it must be destroyed once and for all. Do what must be done." );
	end
	
	if (endingState == Ending.gem_destroyed_party) then
		_turnToTalk(garthId, "R");
		return _reward("Garth Raynal", "Thanks friend. Yes I consider you a friend after all you've done for us. Before I go to the eternal rest.. let me infuse you part of my power.. or of my resistance.", "Garth");
	end
	
	hudPrint "He looks busy.";
end	

shownOnce = false;

function talk(sender)
	if (endingState ~= Ending.maintalk) then
		return;
	end
	
	local startPage = nil;

	if ( shownOnce == false ) then
		startPage = "first";
		shownOnce = true;
	else 
		startPage = "return";
	end


	local dialogue = {
		lockParty = true,
		startPage = startPage,
		pages = {
			{
				id = "first",
				speakerName = "Avatars of Otis Medusa and Garth Raynal",
				speakerMessage = "Stop. There.",
				responses = {
					{ text = "Uh.. err.. we are sorry for, well, raiding your tombs..", nextPage = "sorry" },
					{ text = "(Attack)", nextPage = "attack" },
					{ text = "(Leave)" },					
				} 
			},
			{
				id = "return",
				speakerName = "Avatars of Otis Medusa and Garth Raynal",
				speakerMessage = "So you're back. You can't leave this place without listening to what we have to say.",
				responses = {
					{ text = "(Listen)", nextPage = "step3" },
					{ text = "(Attack)", nextPage = "attack" },
					{ text = "(Leave)" },					
				} 
			},
			{
				id = "sorry",
				speakerMessage = "We don't care about that. We raided our good share of tombs when we were alive. We don't need these treasures anymore now. We only ask you one favor, put the euologies back in their place before leaving. For my son Syd.",
				responses = {
					{ text = "Ok. So, can we leave this place ?", nextPage = "step2" },
					{ text = "(Attack)", nextPage = "attack" },
					{ text = "(Leave)" },					
				} 
			},
			{
				id = "attack",
				speakerMessage = "You can't harm us, and we can't harm you back. But we can block you here undefinitely, until you'll have listened to what we have to say.",
				responses = {
					{ text = "Ok, so, can we leave this place ?", nextPage = "step2" },
					{ text = "We are ready. Speak.", nextPage = "step3" },
					{ text = "(Leave)" },					
				} 
			},
			{
				id = "step2",
				speakerMessage = "Sure. But first you have to listen what we have to say.",
				responses = {
					{ text = "Ok.", nextPage = "step3" },
				}
			},
			{
				id = "step3",
				speakerMessage = "As you might know, we fought a mighty enemy who was controlling people's thoughts by manipulating their dreams from another plane.",
				responses = {
					{ text = "(Listen)", nextPage = "step4" },
				}
			},			
			{
				id = "step4",
				speakerMessage = "One of us betrayed the rest, however, and we ultimately failed. So he can still manipulate people thoughts, but for the most part, he is maintaining a low profile in his activities.",
				responses = {
					{ text = "(Listen)", nextPage = "step5" },
				}
			},			
			{
				id = "step5",
				speakerMessage = "I have studied the planes more than anyone else and yet I have found no proof of the existence of a 'plane of dreams' at least with the powers he says to have.",
				responses = {
					{ text = "(Listen)", nextPage = "step6" },
				}
			},			
			{
				id = "step5b",
				speakerMessage = "We think he channels his power through some kind of focus object. It must be a mighty artifact to sustain that energy without breaking and he must have been in contact with the artifact in the past.",
				responses = {
					{ text = "(Listen)", nextPage = "step6" },
				}
			},					{
				id = "step6",
				speakerMessage = "There are only three times he actually used his powers as far as we know. First, he convinced the judge we were innocent of various crimes and actually saved our lives, probably as a way repay his debt towards us.",
				responses = {
					{ text = "(Listen)", nextPage = "step7" },
				}
			},			
			{
				id = "step7",
				speakerMessage = "Then he convinced a mage named Margonon to steal an ancient artifact from the tomb of Violet Surgeoff in a long abandoned tower. That artifact was found by a group of heroes and then lost again. ",
				responses = {
					{ text = "(Listen)", nextPage = "step8" },
				}
			},			
			{
				id = "step8",
				speakerMessage = "We found it and we hid it here protected by guardians and golems. And yet he convinced countless thieves to come here for that. That sphere must be the focus object.",
				responses = {
					{ text = "(Listen)", nextPage = "step9" },
				}
			},		
			{
				id = "step9",
				speakerMessage = "We didn't want to destroy that, as it contains the soul of the mighty wild mage, Boris Surgeoff. But it's time for it to leave this world. Put it between the two golems. We will do the rest.",
				responses = {
					{ text = "The golems... aren't really.. well you know.. working anymore..", nextPage = "nowork" },
					{ text = "What if we refuse ?", nextPage = "refuse" },
					{ text = "If this is invaluable.. what do we have to gain ?", nextPage = "gain" },					
				} 
			},	
			{
				id = "refuse",
				speakerMessage = "It's your choice. You are the one who will carry an invaluable artifact around and bear the responsibility of their own actions. Make a responsible choice.",
				responses = {
					{ text = "(Leave)", onSelect = self.go.id .. ".script.mainTalkDone" },					
				} 
			},	
			{
				id = "gain",
				speakerMessage = "Come talk to us after you put it there. We won't leave you empty handed.",
				responses = {
					{ text = "OK. Let's go then.", onSelect = self.go.id .. ".script.mainTalkDone" },					
				} 
			},	
			{
				id = "nowork",
				speakerMessage = "We know. Just put it there, we will do the rest. ",
				responses = {
					{ text = "What if we refuse ?", nextPage = "refuse" },
					{ text = "If this is invaluable.. what do we have to gain ?", nextPage = "gain" },			
					{ text = "OK. Let's go then.", onSelect = self.go.id .. ".script.mainTalkDone" },			
				} 
			},	
		}
	}

	GTKGui.Dialogue.startDialogue(dialogue);
end

function _findSoulGemInMiddle()
	local map = xan_gem_target.map;
	local x = xan_gem_target.x;
	local y = xan_gem_target.y;
	
	local found = false;
	
	for e in map:entitiesAt(x, y) do
		if (e.name == "xan_chaos_soulgem") then
			return e;
		end
	end
end

function startEnding()
	if (endingState ~= Ending.waiting_gem) then
		return; 
	end

	local soulgem = _findSoulGemInMiddle();
	
	if (soulgem ~= nil) then
		_setEndingState(Ending.destroy_startUp);
		xan_timer_ending.controller:start();
		xan_lever_1.lever:disable();
		xan_door_spear_2.door:close();
		xan_door_spear_3.door:close();
		xan_door_spear_4.door:close();
	end
end

function getEndingState()
	local found = false;
	
	for k, v in pairs(Ending) do
		if (v == endingState) then
			return k;
		end
	end
	
	return "unk?" .. endingState;
end


function _setEndingState(state)
	if (state < endingState) then
		print("XAN: WARNING STATE DOWNGRADE!!", state, endingState );
		return;
	end

	endingState = state;
	-- print("_setEndingState :=", getEndingState());

end

function golemCanDie()
	return endingState >= 4;
end

function _sealDungeon()
	xan_dungeon_seal.obstacle:enable();
	xan_dungeon_seal.projectilecollider:enable();
	xan_dungeon_seal.model:enable();
	xan_fake_wall_2.door:close();
end

function ending()
	if (endingState == Ending.waiting_gem or endingState == Ending.destroy_startUp) then
		xan_magma_golem_1.aliveAgainParticles:enable();
		xan_magma_golem_2.aliveAgainParticles:enable();
		playSound "generic_spell";
		_setEndingState(Ending.destroy_turnGolems);
		return;
	end

	if (endingState == Ending.destroy_turnGolems) then
		if (xan_magma_golem_1.facing ~= 2) then
			xan_magma_golem_1.brain:turnTowardsDirection(2);
			return;
		end
		if (xan_magma_golem_2.facing ~= 0) then
			xan_magma_golem_2.brain:turnTowardsDirection(0);
			return;
		end
		if (xan_magma_golem_1.facing == 2) and (xan_magma_golem_2.facing == 0) then
			_setEndingState(Ending.destroy_golemsHit);
		end
	end
	
	if (endingState == Ending.destroy_golemsHit) then
		xan_magma_golem_1.brain:performAction("groundPound");
		xan_magma_golem_2.brain:performAction("groundPound");
		_setEndingState(Ending.destroy_destroyGem);
	end
	
	if (endingState == Ending.destroy_destroyGem) then
		local soulgem = _findSoulGemInMiddle();
		soulgem:destroy();
		
		xan_magma_golem_1.aliveAgainParticles:stop();
		xan_magma_golem_2.aliveAgainParticles:stop();
		
		xan_gem_target:spawn("xan_soulgem");
		
		_setEndingState(Ending.destroy_destroyGolems);
		return;
	end
	
	if (endingState == Ending.destroy_destroyGolems) then
		xan_magma_golem_1.monster:die();
		xan_magma_golem_2.monster:die();
		_setEndingState(Ending.destroy_cleanUp);
		return;
	end
	
	if (endingState == Ending.destroy_cleanUp) then
		xan_timer_ending.controller:stop();
		_setEndingState(Ending.gem_destroyed_party);
		xan_lever_1.lever:enable();
		xan_door_spear_2.door:open();
		xan_door_spear_3.door:open();
		xan_door_spear_4.door:open();
		for i = 1, 4 do party.party:getChampion(i):gainExp(1500); end
	end
end


function _loseEnding(state)
	_setEndingState(state);
	xan_otis_teleporter.controller:activate();
	xan_garth_teleporter.controller:activate();
	xan_brothers_teleporter.controller:activate();
	xan_magma_golem_1.monster:die();
	xan_magma_golem_2.monster:die();
	xan_lever_1.lever:enable();
	xan_door_spear_2.door:open();
	xan_door_spear_3.door:open();
	xan_door_spear_4.door:open();
	xan_timer_ending.controller:stop();
	_killGarth();
	_killOtis();
end

function sylinaEnding()
	local note_text = [[
How did you idiots think to stand the power of the gem ?

Luckily I found you. Stay calm, I'm taking the gem to the
golems for its final trip. Let's close this story once and for all.

Hope to meet you again, so that I can punch your faces to a nice
purple shade,

Sylina.
]];	


	if (endingState ~= Ending.waiting_gem) then
		return;
	end

	_loseEnding(Ending.gem_destroyed_sylina);
	
	local aliveCount = 0;
	
	for i = 1, 4 do 
		if (party.party:getChampion(i):isAlive()) then
			aliveCount = aliveCount + 1;
		end
	end
	

	for i = 1, 4 do 
		local c = party.party:getChampion(i);
		
		for s = 1, 32 do
			local e = c:getItem(s);
			
			if e and (e.go.name == "xan_chaos_soulgem") then
				c:removeItemFromSlot(s);

				if (c:isAlive() and (aliveCount > 1)) then
					c:damage(10000, "physical");
					note_text = "Ooops. I hit too hard methinks.\nWell, one less fool in the world.\n\n" .. note_text;
				end

				party.party:wakeUp(true);
				hudPrint "You heard a little noise while sleeping. When you wake up, it's too late.";

				local note = party:spawn("note")
				note.scrollitem:setScrollText(note_text);
				
				break;
			end
		end
	end
end




function testAE()
	_setEndingState(Ending.waiting_gem);
	sylinaEnding();
end

function _destroySmart(gameObject)
	gameObject:removeAllComponents();
	local model = gameObject:createComponent("Model")
	
	model:setModel("assets/models/items/note.fbx");
	model:updateLods();
	
	local item = gameObject:createComponent("Item");
	
	item:setUiName("Note");
	item:setGfxIndex(114);
	item:setWeight(0.1);
	
	gameObject:createComponent("ScrollItem"):setScrollText [[
Uh. Thanks.
I took the gem.

Eugene.
]];
	
	item:updateBoundingBox();
end



function abandonedEnding(soulgem)
	if (endingState ~= Ending.waiting_gem) then
		return;
	end

	if (soulgem == nil) then
		print("XAN: SOULGEM NIL!");
		return;
	end
		
	_loseEnding(Ending.gem_destroyed_abandoned);

	_destroySmart(soulgem);
	
	local note = xan_floor_corpse_entrance:spawn("note")
	note.scrollitem:setScrollText [[
The gem is gone forever, I managed to find it.

Somebody must have abandoned it.
I'm not smart but, hey, that was dumb as a 
smoked trout. It's called smoked for that
reason, you see ?

Now it's gone forever. Let this place rest 
in peace, together with all the souls here
buried.

Eugene.
]];
	
end














