g_BlindUntil = 0;
CONDITIONS = { "poison", "diseased", "paralyzed", "haste", "rage", "fire_shield", "shock_shield", "poison_shield", "frost_shield", "invisibility" }

OTIS_GHOST = -999
GARTH_GHOST = -998
TIMEOUT = 10; -- timeout in secs before aborting soul capture

CHEATS = 
{
	{ title="Wild Surge", detail="Triggers the next wild surge.", callback="test" },
}



function printSurge(msg)
	hudPrint("Wild Magic Surge! : " .. msg)
end

g_tested = 0;

function test()
	g_tested = g_tested + 1;
	print("Testing wild surge", g_tested);
	
	wildSurge(party.party:getChampion(4), g_tested);
	
	if (g_tested == 20) then
		g_tested = 0;
	end
end


function _applyCondition(condition, value)
	for i = 1, 4 do
		local c = party.party:getChampion(i);
		if (c:isAlive() and c:getEnabled()) then
			if (condition) then
				c:setConditionValue(condition, value);
			else
				c:setConditionValue(CONDITIONS[math.random(1, #CONDITIONS)], value);
			end
		end
	end
end

function wildSurgeRandom(caster, chance)
	local dice = math.random(1, 100);
	
	if (dice <= chance) then
		xan_wildmage.script.wildSurge(caster, math.random(1, 20));
	end
end



function wildSurge(caster, surge)
	local DEFAULT_DUR = 40;

	if (surge == 1) then
		party.party:swapChampions(1, 4)
		party.party:swapChampions(2, 3)
		printSurge("Let's do the dance!");	
	elseif (surge == 2) then
		party.party:heal()
		printSurge("You got healed.");	
	elseif (surge == 3) then 
		_applyCondition("paralyzed", 2);
		printSurge("You can't move!");
	elseif (surge == 4) then
		_applyCondition("haste", DEFAULT_DUR);
		printSurge("You all feel quicker!");
	elseif (surge == 5) then
		_applyCondition("invisibility", DEFAULT_DUR);
		printSurge("Hey ? Can you see me ?");	
	elseif (surge == 6) then
		spawn("fireball_medium", party.level, party.x, party.y, party.facing);
		printSurge("BOOM!");		
	elseif (surge == 7) then
		party.party:playScreenEffect("teleport_screen");
		printSurge("Ooooh.. sparkles!");			
	elseif (surge == 8) then
		local dx, dy = getForward(party.facing);
		spawn("fireburst", party.level, party.x + dx, party.y + dy, party.facing);
		printSurge("boom!");
	elseif (surge == 9) then
		_applyCondition("rage", DEFAULT_DUR);
		printSurge("..GRRRRRR!");			
	elseif (surge == 10) then
		_applyCondition("water_breathing", 300);
		printSurge("You smell fishy");			
	elseif (surge == 11) then
		caster:regainEnergy(1000);
		printSurge("You feel refreshed!");			
	elseif (surge == 12) then 
		party:spawn("silver_roach");
		party:spawn("smoked_bass");
		party:spawn("bread");
		party:spawn("bread");
		party:spawn("bread");
		party:spawn("bread");
		party:spawn("bread");
		printSurge("Miracles happen. And thanks for all the fish!");			
	elseif (surge == 13) then -- MARK KNOFFER
		party:spawn("xan_mark_knoffer");
		printSurge("There's a new weapon... it rocks!");			
	elseif (surge == 14) then
		spawn("ice_shards", party.level, party.x, party.y, party.facing);
		printSurge("ouch!");			
	elseif (surge == 15) then
		_applyCondition(nil, DEFAULT_DUR);
		printSurge("You all feel strange");			
	elseif (surge == 16) then
		local dx, dy = getForward(party.facing);
		spawn("ice_shards", party.level, party.x + dx, party.y + dy, party.facing);
		printSurge("zing!");	
	elseif (surge == 17) then
		for i = 1, 4 do
			party.party:getChampion(i):swapWeaponSets();
		end
		printSurge("Tah-Dah!");	
	elseif (surge == 18) then
		for i = 1, 4 do
			party.party:getChampion(i):modifyFood(1000);
		end
		printSurge("Slurp!");	
	elseif (surge == 19) then
		for i = 1, 4 do
			party.party:getChampion(i):modifyFood(-1000);
		end
		printSurge("I'm hungry!");	
	elseif (surge == 20) then
		printSurge("Double surge!");
		wildSurge(caster, math.random(1, 19));
		wildSurge(caster, math.random(1, 19));
	end
end


g_soulgemFull = false;
g_trapSoulExp = 0;
g_trapSoulTime = 0;


function castEntrapSoul(champion, x, y, direction, elevation, skillLevel)
	local h1 = champion:getItem(ItemSlot.Weapon);
	local h2 = champion:getItem(ItemSlot.OffHand);
	local soulgem = nil;

	if h1 and (h1.go.name == "xan_soulgem") then
		soulgem = h1;
	elseif h2 and (h2.go.name == "xan_soulgem") then
		soulgem = h2;
	else
		hudPrint("The entrapment failed.");
		return;
	end
	
	if (g_soulgemFull) then
		soulgem.go.equipmentItem:setEnergy(0);
		g_soulgemFull = false;
		_setSoulgemDesc(soulgem, "Currently empty.", 0);
		hudPrint("The soul-gem has been emptied.");
	else
		local dx, dy = getForward(party.facing);
		spawn("xan_soulTrapper", party.level, party.x + dx, party.y + dy, party.facing, party.elevation);
	end
end

function _setSoulgemDesc(soulgem_item, desc, icon)
	soulgem_item:setGameEffect("Entrap soul : " .. desc);
	soulgem_item:setGfxIndex(icon);
end

function registerMonsterForSoul(entity)
	g_trapSoulExp = nil;
	g_trapSoulTime = 0;

	if (entity.monster == nil) then
		return;
	end

	if (entity.name == "xan_otis_ghost") then
		g_trapSoulExp = OTIS_GHOST;
	elseif (entity.name == "xan_garth_ghost") then
		g_trapSoulExp = GARTH_GHOST;
	else
		g_trapSoulExp = entity.monster:getExp();
	end
	
	g_trapSoulTime = Time.currentTime();

	--print("registering trap soul target:", g_trapSoulExp, g_trapSoulTime);
	
	if (g_trapSoulExp) then
		entity.monster:addConnector("onDie", self.go.id, "onTrapSoulMonsterDie");
	end
end

function drawUI(context)
	local timeDelta = Time.currentTime() - g_trapSoulTime;

	if (timeDelta < TIMEOUT and g_trapSoulTime > 0 and timeDelta > 0) then
		local H = 200;
		local X = 16;
		local W = 8;
		local y = (context.height - H) / 2;
		local size = math.floor((TIMEOUT - timeDelta) / TIMEOUT * H);
		
		context.color(192, 192, 192, 128);

		context.drawRect(X, y+H-size, W, size);
		
		context.color(255, 255, 255, 255);

		context.drawImage2("mod_assets/rooms/xan/assets/atlas.dds", -4, y + H , 0, 0, 75, 75, 48, 48);
		
		
		context.drawRect(X, y, 1, H);
		context.drawRect(X+W, y, 1, H+1);
		context.drawRect(X, y+H, W, 1);
		context.drawRect(X, y, W, 1);
	end
end

function onTrapSoulMonsterDie()
	local timeDelta = Time.currentTime() - g_trapSoulTime;
	local soulgem = nil;
	
	for i = 1, 4 do
		local champion = party.party:getChampion(i);
		
		local h1 = champion:getItem(ItemSlot.Weapon);
		local h2 = champion:getItem(ItemSlot.OffHand);

		if (champion:getEnabled() and champion:isAlive()) then
			if h1 and (h1.go.name == "xan_soulgem") then
				soulgem = h1;
				break;
			elseif h2 and (h2.go.name == "xan_soulgem") then
				soulgem = h2;
				break;
			end
		end
	end
	
	if (soulgem == nil) or (timeDelta > TIMEOUT) or (g_trapSoulExp == nil) then
		hudPrint("You failed to trap the soul.");
		return;
	end
	
	g_trapSoulTime = 0;
	
	if (g_trapSoulExp == OTIS_GHOST) then
		xan_ending.script.setTrappedSoulBrother();
		hudPrint("You trapped Otis Medusa's soul!.");
		_setSoulgemDesc(soulgem, "In a vile act, you trapped the soul of Otis Medusa. Energy +40/+20% regeneration, Resist fire +30", 14);
		soulgem.go.equipmentItem:setEnergy(40);
		soulgem.go.equipmentItem:setResistFire(30);
		soulgem.go.equipmentItem:setEnergyRegenerationRate(20);
	elseif (g_trapSoulExp == GARTH_GHOST) then
		xan_ending.script.setTrappedSoulBrother();
		hudPrint("You trapped Garth Raynal's soul!.");
		_setSoulgemDesc(soulgem, "In a vile act, you trapped the soul of Garth Raynal. Energy +40/+20% regeneration, Resist cold +30", 15);
		soulgem.go.equipmentItem:setEnergy(40);
		soulgem.go.equipmentItem:setResistCold(30);
		soulgem.go.equipmentItem:setEnergyRegenerationRate(20);
	elseif (g_trapSoulExp < 375) then
		soulgem.go.equipmentItem:setEnergy(5);
		_setSoulgemDesc(soulgem, "Energy +5", 1);
		hudPrint("You trapped a minor soul.");
	elseif (g_trapSoulExp < 750) then
		soulgem.go.equipmentItem:setEnergy(15);
		_setSoulgemDesc(soulgem, "Energy +15", 2);
		hudPrint("You trapped a soul.");
	elseif (g_trapSoulExp < 1500) then
		_setSoulgemDesc(soulgem, "Energy +25, Energy regeneration +10%, Resists : +5", 3);
		soulgem.go.equipmentItem:setEnergy(25);
		soulgem.go.equipmentItem:setEnergyRegenerationRate(10);
		soulgem.go.equipmentItem:setResistCold(5);
		soulgem.go.equipmentItem:setResistFire(5);
		soulgem.go.equipmentItem:setResistShock(5);
		soulgem.go.equipmentItem:setResistPoison(5);
		hudPrint("You trapped a major soul.");
	else
		_setSoulgemDesc(soulgem, "Energy +40, Energy regeneration +20%, Resists : +10", 4);
		soulgem.go.equipmentItem:setEnergy(40);
		soulgem.go.equipmentItem:setEnergyRegenerationRate(20);
		soulgem.go.equipmentItem:setResistCold(10);
		soulgem.go.equipmentItem:setResistFire(10);
		soulgem.go.equipmentItem:setResistShock(10);
		soulgem.go.equipmentItem:setResistPoison(10);
		hudPrint("You trapped a majestic soul.");
	end
	
	or3_manager.script.advanceStatistic("xan_souls_captured", 1);
	
	g_soulgemFull = true;
end



function initAchievements()
	or3_manager.script.registerStatistic {
		id = "xan_souls_captured",
		title = "Captured souls",
		description = "Number of souls captured in the soulgem.",
	}
	
	or3_manager.script.registerAchievement {
		id = "xan_soulgem_first",
		title = "Soul Captor",
		description = "Capture your first soul!",
		xp = 250,
		statistic_id = "xan_souls_captured",
		statistic_amount = 1,
	}
end



delayedCall(self.go.id, 0.1, "initAchievements");






